------------------------------------------------------------------------------------------------------------
-- ################### DATA ####################### --
------------------------------------------------------------------------------------------------------------

DoTimer_Settings = {} --table for user-defined settings
local version = "1.0.8.2" --for the help command
local date_uploaded = "August 24, 2006" --for the help command
local Old_CSBN,Old_CS,Old_UA,Old_CPA,Old_STU,Old_TU,Old_SST --the old functions for hooking
local elapsed,loaded,watchedspell,watchedheal,watchedenslave,spelltargeted,class,debugchannel,preventingimmol --random variables i use
local lasttarget = {} --a table holding data for my last target
local casted = {} --governs the currently casted debuffs.  entries are 1-10 targets, which in turn are 1-20 debuffs and the target name
local incomingspell = {}  --the table created for a spell.  it lasts until the spell is successfully cast, and is created when the spell begins to be cast
local sentspell = {} --another table for a spell.  it's created when the spell is successfully cast, and lasts until the debuff afflicts the target
local finalspell = {} --a final table for a spell.  created when the debuff most likely lands on the target, lasts until the icon for that debuff appears
local castpetspell = {} --the table for pet spellcasts
local casthealspell = {} --table for friendly duration spells
local castenslavespell = {} --table for enslave demon spells
local sentpetspell = {} --table for pet spells, to catch resists/whatever
local finalpetspell = {} --another for pet spells, to await the icon
local resistmsg = string.gsub(SPELLRESISTSELFOTHER,"%%.-s","(.+)") --the chat message sent when a spell is resisted
local evademsg = string.gsub(SPELLEVADEDSELFOTHER,"%%.-s","(.+)") --the chat message sent when a spell is evaded
local immunemsg = string.gsub(SPELLIMMUNESELFOTHER,"%%.-s","(.+)") --the chat message sent when something is immune to your spell
local reflectmsg = string.gsub(SPELLREFLECTSELFOTHER,"%%.-s","(.+)") --the chat message sent when your spell is reflected back to you
local petresistmsg = string.gsub(SPELLRESISTOTHEROTHER,"%%.-s","(.+)") --the chat message sent when a pet spell is resisted 
local petevademsg = string.gsub(SPELLEVADEDOTHEROTHER,"%%.-s","(.+)") --the chat message sent when a pet spell is evaded
local petimmunemsg = string.gsub(SPELLIMMUNEOTHEROTHER,"%%.-s","(.+)") --the chat message sent when something is immune to pet's spell
local petreflectmsg = string.gsub(SPELLREFLECTOTHEROTHER,"%%.-s","(.+)") --the chat message sent when your pet's spell is reflected back to your pet
local spellhitmsg = string.gsub(string.gsub(SPELLLOGSCHOOLSELFOTHER,"%%.-d","%%d+"),"%%.-s","(.+)") --the chat message sent when your spell hits for some amount
local spellcritmsg = string.gsub(string.gsub(SPELLLOGCRITSCHOOLSELFOTHER,"%%d","%%d+"),"%%.-s","(.+)") --same but for crits
local diesmsg = string.gsub(UNITDIESOTHER,"%%.-s","(.+)") --the chat message sent when something dies
local fadesmsg = string.gsub(AURAREMOVEDOTHER,"%%.-s","(.+)") --the chat message sent when a debuff fades from something
local failedmsg = string.gsub(SPELLFAILCASTSELF,"%%.-s","(.+)") --when you fail to cast a spell for some reason
local begincastmsg = string.gsub(SPELLCASTOTHERSTART,"%%.-s","(.+)") --in the pet msg for your pet beginning to cast a spell (seduction)
local slainmsg = string.gsub(SELFKILLOTHER,"%%.-s","(.+)") --when you had the killing blow for a death
local spells,petspells,healspells,enslavespells = {},{},{},{} --spells are offensive duration spells, petspells are pet duration spells,  healspells are friendly duration spells, and enslavespells are enslaving demon spells

------------------------------------------------------------------------------------------------------------
-- ################ LOCALIZATION ################### --
------------------------------------------------------------------------------------------------------------

function DoTimer_ReturnEnglish(spellname) --returns the english name of the spell
	local tables = {BOOKTYPE_SPELL,BOOKTYPE_PET}
	local english,texture
	for index,value in tables do
		local i = 1
		while GetSpellName(i,value) do
			local spell = GetSpellName(i,value)
			if spell == spellname then 
				texture = GetSpellTexture(i,value)
				break
			end
			i = i + 1
		end
	end
	if texture and DoTimer_SpellData[class] and DoTimer_SpellData[class][texture] then return DoTimer_SpellData[class][texture].name end
	return "unknown"
end

function DoTimer_ToLocale(spellname) -- returns the localized name of the english spell
	for index,value in DoTimer_SpellData[class] do
		if value.name == spellname then
			local i = 1
			while GetSpellName(i,BOOKTYPE_SPELL) do
				local texture = GetSpellTexture(i,BOOKTYPE_SPELL)
				if texture == index then
					local spell = GetSpellName(i,BOOKTYPE_SPELL)
					return spell
				end
				i = i + 1
			end
		end
	end
end

------------------------------------------------------------------------------------------------------------
-- ############## BASIC FUNCTIONS ################### --
------------------------------------------------------------------------------------------------------------
	
function DoTimer_OnLoad()
	this:RegisterEvent("PLAYER_ENTERING_WORLD")
	this:RegisterEvent("SPELLCAST_STOP")
	this:RegisterEvent("CHAT_MSG_SPELL_SELF_DAMAGE")
	this:RegisterEvent("CHAT_MSG_COMBAT_HOSTILE_DEATH")
	this:RegisterEvent("PLAYER_DEAD")
	this:RegisterEvent("SPELLCAST_DELAYED")
	this:RegisterEvent("PLAYER_REGEN_ENABLED")
	this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER")
	this:RegisterEvent("CHAT_MSG_SPELL_PET_DAMAGE")
	this:RegisterEvent("PLAYER_TARGET_CHANGED")
	this:RegisterEvent("CHAT_MSG_SPELL_FAILED_LOCALPLAYER")
	this:RegisterEvent("PET_BAR_UPDATE_COOLDOWN")
	this:RegisterEvent("UNIT_PET")
	SLASH_DOTIMER1 = "/dotimer" --creating the slash command
	SLASH_DOTIMER2 = "/dot" --and the other one, for those who are lazy
	SlashCmdList["DOTIMER"] = DoTimer_Commands
	if DEFAULT_CHAT_FRAME then DEFAULT_CHAT_FRAME:AddMessage("DoTimer by Asheyla loaded! Access this addon by typing \"/dotimer\" or \"/dot\"") end  --a little PR never hurts ^^
	local oldfunc = WorldFrame:GetScript("OnMouseDown") -- hooks clicking on the worldframe so that targeting people for beneficial spells by clicking on their 3d model works
	if not oldfunc then oldfunc = function() end end
	WorldFrame:SetScript("OnMouseDown",function() oldfunc(); DoTimer_OnWorldClick(); end)
end

function DoTimer_AddText(msg) --basic output function
	if DEFAULT_CHAT_FRAME then DEFAULT_CHAT_FRAME:AddMessage(msg) end
end

function DoTimer_AddMenuText(msg,fromgui) -- will output a msg if the text menu was accessed; not the GUI menu
	if not fromgui then DoTimer_AddText(msg) end
end

function DoTimer_Debug(msg) --makes a debug msg if i have that turned on
	if debugchannel then
		if debugchannel ~= "" and getglobal("ChatFrame"..debugchannel) then getglobal("ChatFrame"..debugchannel):AddMessage(msg)
		else DoTimer_AddText(msg)
		end
	end
end

function DoTimer_OnEvent(event)
	if event == "PLAYER_ENTERING_WORLD" and not loaded then DoTimer_Startup() -- when you first log in
	elseif event == "SPELLCAST_DELAYED" then --mod the spell cast length for the most recent incomingspell entry that has a casttime
		DoTimer_Debug(event)
		if arg1 then DoTimer_Debug(arg1) end
		--local entry = table.getn(incomingspell)
		--if entry > 0 and incomingspell[entry].casttime > 0 then incomingspell[entry].casttime = incomingspell[entry].casttime + (arg1 / 1000) end
		if watchedspell then
			local lasti,lastcast
			for i = table.getn(incomingspell),1,-1 do --figuring out the last spell cast that had a casttime
				if incomingspell[i].casttime > 0 then
					if incomingspell[i].timestart > (lastcast or 0) then
						incomingspell[i].casttime = incomingspell[i].casttime + (arg1 / 1000)
						DoTimer_Debug("modding the cast time of "..incomingspell[i].spell)
						break
					end
				end
			end
		end
		if watchedheal then
			local lasti,lastcast
			for i = table.getn(casthealspell),1,-1 do --figuring out the last spell cast that had a casttime
				if casthealspell[i].casttime > 0 then
					if casthealspell[i].timestart > (lastcast or 0) then
						casthealspell[i].casttime = casthealspell[i].casttime + (arg1 / 1000)
						DoTimer_Debug("modding the cast time of "..casthealspell[i].spell)
						break
					end
				end
			end		
		end
		if watchedenslave then
			local lasti,lastcast
			for i = table.getn(castenslavespell),1,-1 do --figuring out the last spell cast that had a casttime
				if castenslavespell[i].casttime > 0 then
					if castenslavespell[i].timestart > (lastcast or 0) then
						castenslavespell[i].casttime = castenslavespell[i].casttime + (arg1 / 1000)
						DoTimer_Debug("modding the cast time of "..castenslavespell[i].spell)
						break
					end
				end
			end		
		end
	elseif event == "CHAT_MSG_SPELL_FAILED_LOCALPLAYER" then --if a spell fails, this code is run
		DoTimer_Debug(event)
		if arg1 then DoTimer_Debug(arg1) end
		local spell,reason = DoTimer_ParseString(arg1,failedmsg)
		if watchedspell then
			local lastvalue,lasti,lastcast
			for i = table.getn(incomingspell),1,-1 do --figuring out the last spell cast
				if incomingspell[i].spell == spell and incomingspell[i].timestart > (lastcast or 0) then
					lastvalue = incomingspell
					lasti = i
					lastcast = incomingspell[i].timestart
				end
			end
			for i = table.getn(sentspell),1,-1 do
				if sentspell[i].spell == spell and sentspell[i].timestart > (lastcast or 0) then
					lastvalue = sentspell
					lasti = i
					lastcast = sentspell[i].timestart
				end
			end
			if lastcast then 
				DoTimer_Debug(lastvalue[lasti].spell.." has failed before being successfully cast, removing it")
				table.remove(lastvalue,lasti) 
				if (table.getn(incomingspell) > 0 or table.getn(sentspell) > 0) then watchedspell = 1 else watchedspell = nil end
			end
		end
		if watchedheal then
			for i = table.getn(casthealspell),1,-1 do
				if casthealspell[i].spell == spell then
					DoTimer_Debug(casthealspell[i].spell.." failed before being successfully cast; removing it")
					table.remove(casthealspell,i)
					if table.getn(casthealspell) > 0 then watchedheal = 1 else watchedheal = nil end
					break
				end
			end
		end
		if watchedenslave then
			for i = table.getn(castenslavespell),1,-1 do
				if castenslavespell[i].spell == spell then
					DoTimer_Debug(castenslavespell[i].spell.." failed before being successfully cast; removing it")
					table.remove(castenslavespell,i)
					if table.getn(castenslavespell) > 0 then watchedenslave = 1 else watchedenslave = nil end
					break
				end
			end
		end
	elseif event == "SPELLCAST_STOP" then
		DoTimer_Debug(event)
		if arg1 then DoTimer_Debug(arg1) end
		--redo to include the multiple incomingspell entries, delete the one used
		if watchedspell then --theres a dot awaiting a spellcast_stop
			for i = table.getn(incomingspell),1,-1 do
				if (GetTime() >= incomingspell[i].timestart + incomingspell[i].casttime - .5) then
					DoTimer_Debug("sending "..incomingspell[i].spell.." to sentspell")
					local sentspellentry = {} --now this spell will wait .5 seconds for interrupts, resists, immunes, etc.
					for index,value in incomingspell[i] do sentspellentry[index] = value end
					sentspellentry.casttime = .5
					sentspellentry.timestart = GetTime()
					table.remove(incomingspell,i)
					table.insert(sentspell,sentspellentry)
					if table.getn(sentspell) == 1 then DoTimerDelayFrame:SetScript("OnUpdate",function() DoTimer_DelayTimer() end) end
					if (table.getn(incomingspell) > 0 or table.getn(sentspell) > 0) then watchedspell = 1 else watchedspell = nil end
					break
				end
			end
		end
		if watchedheal then --we were casting a heal spell
			for i = table.getn(casthealspell),1,-1 do
				if casthealspell[i].target then --the most recent entry which has been given target data
					DoTimer_Debug("creating a timer for "..casthealspell[i].spell)
					DoTimer_CreateSpellTimer(casthealspell[i]) --time to make a timer
					table.remove(casthealspell,i)
					if table.getn(casthealspell) > 0 then watchedheal = 1 else watchedheal = nil end
					break
				end
			end
		end
		if watchedenslave then --theres a dot awaiting a spellcast_stop
			for i = table.getn(castenslavespell),1,-1 do
				if (GetTime() >= castenslavespell[i].timestart + castenslavespell[i].casttime - .5) then
					DoTimer_Debug("making "..castenslavespell[i].spell.." to eligible for detection")
					castenslavespell[i].finished = 1
					break
				end
			end
		end
	elseif event == "UNIT_PET" and arg1 == "player" then
		DoTimer_Debug(event)
		if arg1 then DoTimer_Debug(arg1) end
		local found
		if UnitExists("pet") then DoTimer_Debug("we have a pet") else DoTimer_Debug("we do not have a pet") end
		if UnitExists("pet") then found = DoTimer_ReturnTable(UnitName("pet"),UnitSex("pet"),UnitLevel("pet")) else found = 0 end
		for i = table.getn(casted),1,-1 do
			if not (i == found) then
				for id = table.getn(casted[i]),1,-1 do
					if casted[i][id].type == "enslave" then 
						DoTimer_Debug("removing enslave timer; inaccurate")
						DoTimer_RemoveTimer(i,id) --removing all enslave timers whenever pet changes
					end
				end
			end
		end
		if watchedenslave and UnitExists("pet") then --new enslave to be added
			for i = table.getn(castenslavespell),1,-1 do
				if castenslavespell[i].finished then
					DoTimer_Debug("creating a timer for "..castenslavespell[i].spell)
					castenslavespell[i].target = UnitName("pet")
					castenslavespell[i].targettype = DoTimer_ReturnTargetType("pet")
					castenslavespell[i].targetlevel = UnitLevel("pet")
					castenslavespell[i].targetsex = UnitSex("pet")
					DoTimer_CreateSpellTimer(castenslavespell[i])
					table.remove(castenslavespell,i)
					if table.getn(castenslavespell) > 0 then watchedenslave = 1 else watchedenslave = nil end
					break
				end
			end
		end
	elseif event == "PLAYER_TARGET_CHANGED" then --time to make the last target's timers eligible for depreciation
		local newtarget
		if UnitName("target") then newtarget = {UnitName("target"),UnitSex("target"),UnitLevel("target")} end
		--DoTimer_AddText("flag1") --flag
		--DoTimer_AddText(newtarget)
		--DoTimer_AddText(lasttarget)
		for i = 1,table.getn(casted) do casted[i].eligible = 1 end --all tables are now eligible for depreciated timers
		local found = DoTimer_ReturnTable(lasttarget[1],lasttarget[2],lasttarget[3])
		if newtarget and newtarget[1] == lasttarget[1] and newtarget[2] == lasttarget[2] and newtarget[3] == lasttarget[3] then
			DoTimer_Debug("new target identical to old target")
			--DoTimer_AddText("flag2") --flag
			if found then
				--DoTimer_AddText("flag3") --flag
				DoTimer_Debug("depreciating all appreciated timers for "..casted[found].target)
				for i = table.getn(casted[found]),1,-1 do
					if DoTimer_TimerIsAppreciated(found,i) then DoTimer_DepreciateTimer(found,i) end --if we are switching targets to one that is "identical" to the previous, automatically depreciate since we know they are inaccurate
				end
			end
		end
		if UnitName("target") then lasttarget = {UnitName("target"),UnitSex("target"),UnitLevel("target")} else lasttarget = {} end
	elseif event == "CHAT_MSG_SPELL_SELF_DAMAGE" then --need to delete the new table if resist/evade so it never creates a timer, also need to look for conflag
		--redo the deleting thing
		local spellname,target --looking for all the random things that would cause a failed timer
		spellname,target = DoTimer_ParseString(arg1,resistmsg)
		if not (spellname and target) then
			spellname,target = DoTimer_ParseString(arg1,evademsg)
		end
		if not (spellname and target) then
			spellname,target = DoTimer_ParseString(arg1,immunemsg)
		end
		if not (spellname and target) then
			spellname,target = DoTimer_ParseString(arg1,reflectmsg)
		end
		if spellname and target then
			if DoTimer_ReturnEnglish(spellname) == "Conflagrate" then
				DoTimer_Debug("conflag was cast, but failed to apply")
				if not (UnitName("target") == target) then return end --ignoring if you untargetted the mob after casting conflag, makes things overly complicated
				local found = DoTimer_ReturnTable(target,UnitSex("target"),UnitLevel("target"))
				if found then --first look for appreciated timers, then depreciated (the most recently depreciated immolate)
					local removed
					for i = table.getn(casted[found]),1,-1 do --checking that target for immolate
						if DoTimer_ReturnEnglish(casted[found][i].spell) == "Immolate" and DoTimer_TimerIsAppreciated(found,i) then
							DoTimer_Debug(casted[found].target.." had an appreciated immol, removed it")
							DoTimer_RemoveTimer(found,i)
							removed = 1
							break
						end
					end
					if not removed then
						local id,cast
						for i = table.getn(casted[found]),1,-1 do
							if DoTimer_ReturnEnglish(casted[found][i].spell) == "Immolate" and (casted[found][i].dep) then
								if casted[found][i].depstart >= (cast or 0) then
									cast = casted[found][i].depstart
									id = i
								end
							end
						end
						if id then 
							DoTimer_Debug(casted[found].target.." had a depreciated immol, removed it")
							DoTimer_RemoveTimer(found,id) 
						end
					end
				end
			end
		end
		if spellname and target and watchedspell then
			DoTimer_Debug(event)
			if arg1 then DoTimer_Debug(arg1) end
			local lasti
			for i = table.getn(sentspell),1,-1 do --figuring out the last spell cast that matches this data
				if sentspell[i].spell == spellname and sentspell[i].target == target then
					lasti = i
					break
				end
			end
			if lasti then 
				DoTimer_Debug(sentspell[lasti].spell.." was not successfully applied to mob; removing it")
				table.remove(sentspell,lasti) 
				if table.getn(sentspell) == 0 then DoTimerDelayFrame:SetScript("OnUpdate",nil) end
				if (table.getn(incomingspell) > 0 or table.getn(sentspell) > 0) then watchedspell = 1 else watchedspell = nil end
			end
		end
		--still need to add in conflag!  immolate *should* fade with the aura_gone msg, but we have to make sure of this by deleting it manually as well.
		spellname,target = DoTimer_ParseString(arg1,spellhitmsg) --checking for a conflagrate
		if not (spellname and target) then
			spellname,target = DoTimer_ParseString(arg1,spellcritmsg)
		end
		if spellname and target then
			if DoTimer_ReturnEnglish(spellname) == "Conflagrate" then
				DoTimer_Debug("conflag was cast, applied successfully")
				if not (UnitName("target") == target) then return end --ignoring if you untargetted the mob after casting conflag, makes things overly complicated
				local found = DoTimer_ReturnTable(target,UnitSex("target"),UnitLevel("target"))
				if found then --first look for appreciated timers, then depreciated (the most recently depreciated immolate)
					local removed
					for i = table.getn(casted[found]),1,-1 do --checking that target for immolate
						if DoTimer_ReturnEnglish(casted[found][i].spell) == "Immolate" and DoTimer_TimerIsAppreciated(found,i) then
							DoTimer_Debug(casted[found].target.." had an appreciated immol, removed it")
							DoTimer_RemoveTimer(found,i)
							removed = 1
							break
						end
					end
					if not removed then
						local id,cast
						for i = table.getn(casted[found]),1,-1 do
							if DoTimer_ReturnEnglish(casted[found][i].spell) == "Immolate" and (casted[found][i].dep) then
								if casted[found][i].depstart >= (cast or 0) then
									cast = casted[found][i].depstart
									id = i
								end
							end
						end
						if id then 
							DoTimer_Debug(casted[found].target.." had a depreciated immol, removed it")
							DoTimer_RemoveTimer(found,id) 
						end
					end
				end
			end
		end
	elseif event == "PET_BAR_UPDATE_COOLDOWN" then
		DoTimer_Debug(event)
		if arg1 then DoTimer_Debug(arg1) end
		local i = 1
		while GetSpellName(i,BOOKTYPE_PET) do
			local name = GetSpellName(i,BOOKTYPE_PET)
			if DoTimer_ReturnEnglish(name) == "Spell Lock" then
				local start = GetSpellCooldown(i,BOOKTYPE_PET)
				if math.abs(GetTime() - start) <= .5 then
					local unit = "target"
					if UnitExists("pettarget") then unit = "pettarget" end
					if not DoT_OwnSpellOnTarget(name,unit) then 
						DoTimer_Debug("Spell Lock was cast; beginning timer")
						DoTimer_InitiatePetSpellTimer(name)
					end
				end
			end
			i = i + 1
		end
	elseif event == "CHAT_MSG_COMBAT_HOSTILE_DEATH" then --deletion of entries based on death: if target died, remove his entries, else: if it was a player, remove entries, else leave alone.  mob entries will be removed on exit combat
		DoTimer_Debug(event)
		if arg1 then DoTimer_Debug(arg1) end
		local died = DoTimer_ParseString(arg1,diesmsg) --checking if the dead mob had any tables
		if not died then
			died = DoTimer_ParseString(arg1,slainmsg)
		end
		if died == UnitName("target") and UnitIsDead("target") then --your target died, we will delete its entries
			DoTimer_Debug("current target died")
			local found = DoTimer_ReturnTable(died,UnitSex("target"),UnitLevel("target"))
			if found then --sure enough, it did!
				DoTimer_Debug("and it had timers; removing appreciated")
				for i = table.getn(casted[found]),1,-1 do 
					if DoTimer_TimerIsAppreciated(found,i) then DoTimer_RemoveTimer(found,i) end 
				end
				--DoTimer_AddText(died.." died and its entries were removed.")
			end
			local tables = {finalspell,sentspell,incomingspell}
			for index,value in tables do
				for i = table.getn(value),1,-1 do
					if (value[i].target == UnitName("target") and value[i].targetsex == UnitSex("target") and value[i].targetlevel == UnitLevel("target")) then table.remove(value,i) end --removing pretimers for that target
				end
			end
		else --will ignore if mob, will delete if player
			DoTimer_Debug("mob died, not current target, but we are deleting its entries anyway")
			for i = table.getn(casted),1,-1 do
				local found
				if (casted[i].target == died) and not (casted[i].type == "mob") then found = i end
				if found then --sure enough, it did!
					table.remove(casted,found) 
					--DoTimer_AddText(died.." died and its entries were removed.")
				end
			end
			local tables = {finalspell,sentspell,incomingspell}
			for index,value in tables do
				for i = table.getn(value),1,-1 do
					if (value[i].target == died and not (value[i].targettype == "mob")) then table.remove(value,i) end --removing pretimers for that target
				end
			end
		end
		DoTimer_CreateInterface()
	elseif event == "PLAYER_DEAD" then --deleting entries because player died
		DoTimer_Debug(event)
		if arg1 then DoTimer_Debug(arg1) end
		DoTimer_Debug("player died; removing all debuffs")
		for i = table.getn(casted),1,-1 do table.remove(casted,i) end
		DoTimer_CreateInterface()
	elseif event == "CHAT_MSG_SPELL_PET_DAMAGE" then --for the succubus auto-casting seduce; it does not go through the normal function
		local person,spellname = DoTimer_ParseString(arg1,begincastmsg)
		if spellname then
			DoTimer_Debug(event)
			if arg1 then DoTimer_Debug(arg1) end
			if DoTimer_ReturnEnglish(spellname) == "Seduction" then
				DoTimer_Debug("Seduction was cast; beginning a timer for it")
				DoTimer_InitiatePetSpellTimer(spellname) 
			end
		end
		local spellname,target --looking for all the random things that would cause a failed timer
		spellname,target = DoTimer_ParseString(arg1,petresistmsg)
		if not (spellname and target) then
			spellname,target = DoTimer_ParseString(arg1,petevademsg)
		end
		if not (spellname and target) then
			spellname,target = DoTimer_ParseString(arg1,petimmunemsg)
		end
		if not (spellname and target) then
			spellname,target = DoTimer_ParseString(arg1,petreflectmsg)
		end
		if spellname and target then
			DoTimer_Debug(event)
			if arg1 then DoTimer_Debug(arg1) end
			local lasti
			for i = table.getn(sentpetspell),1,-1 do --figuring out the last spell cast that matches this data
				if sentpetspell[i].spell == spellname and sentpetspell[i].target == target then
					lasti = i
					break
				end
			end
			if lasti then 
				DoTimer_Debug(sentpetspell[lasti].spell.." was not successfully applied to mob; removing it")
				table.remove(sentpetspell,lasti) 
				if table.getn(sentpetspell) == 0 then DoTimerPetDelayFrame:SetScript("OnUpdate",nil) end
			end
		end
	elseif event == "PLAYER_REGEN_ENABLED" then --deleting mob tables b/c left combat
		DoTimer_Debug("left combat")
		if preventingimmol then 
			preventingimmol = nil
			DoTimer_AddText("Immolate will not be prevented anymore.")
		end
		DoTimerCombatFrame.time = GetTime()
		DoTimerCombatFrame:SetScript("OnUpdate",function() --we delay the combat check .5 seconds, just to make sure we are really out of combat
			if GetTime() >= this.time + .5 then
				if not UnitAffectingCombat("player") then
					DoTimer_Debug("still out of combat .5 seconds later; removing all non-enslave, non-player timers")
					for i = table.getn(casted),1,-1 do
						if not (casted[i].type == "player") then
							for id = table.getn(casted[i]),1,-1 do
								if not (casted[i][id].type == "enslave") then DoTimer_RemoveTimer(i,id) end
							end
						end
					end
				end
				this:SetScript("OnUpdate",nil)
			end
		end)
	elseif event == "CHAT_MSG_SPELL_AURA_GONE_OTHER" then --checking for debuff fades
		local chatspell,chattarget = DoTimer_ParseString(arg1,fadesmsg)
		--we will delete the timer if 1) the target is our current target, and 2) there are now no occurrences of the debuff on the target
		if DoTimer_intable(chatspell,spells) then --scan target for debuffs; if no more occurrences then we can delete that timer
			DoTimer_Debug(event)
			if arg1 then DoTimer_Debug(arg1) end
			DoTimer_Debug("the spell that faded is a timer spell")
			if chattarget == UnitName("target") and DoT_OwnSpellOnTarget(chatspell) and not DoT_SpellOnTarget(chatspell) then
				local found = DoTimer_ReturnTable(UnitName("target"),UnitSex("target"),UnitLevel("target"))
				if found then
					for i = table.getn(casted[found]),1,-1 do
						if casted[found][i].spell == chatspell and DoTimer_TimerIsAppreciated(found,i) then
							DoTimer_Debug("no more occurrences of the spell, so removing the timer")
							DoTimer_RemoveTimer(found,i)
							break
						end
					end
				end
			end
		elseif DoTimer_intable(chatspell,petspells) then --scan pettarget for pet related spells
			DoTimer_Debug(event)
			if arg1 then DoTimer_Debug(arg1) end
			DoTimer_Debug("it was a pet spell")
			if chattarget == UnitName("pettarget") and DoT_OwnSpellOnTarget(chatspell,"pettarget") and not DoT_SpellOnTarget(chatspell,"pettarget") then
				local found = DoTimer_ReturnTable(UnitName("pettarget"),UnitSex("pettarget"),UnitLevel("pettarget"))
				if found then
					for i = table.getn(casted[found]),1,-1 do
						if casted[found][i].spell == chatspell and (not (DoTimer_ReturnEnglish(chatspell) == "Spell Lock")) and DoTimer_TimerIsAppreciated(found,i) then
							DoTimer_Debug("no more occurrences, removing it")
							DoTimer_RemoveTimer(found,i)
							break
						end
					end
				end
			end
		end
	end
end

function DoTimer_ParseString(text,...) --my prized function for parsing data from strings.  it was not written for this addon, and I don't feel like commenting it
	local entries = {}
	local start = 1
	local savetext = text
	for i = 1,arg.n,2 do
    	local search = arg[i]
		local newsearch,starter,ender = search,"",""
		if string.sub(search,1,1) == "^" then
			newsearch = string.sub(newsearch,2)
			starter = "^"
		end
		if string.sub(search,string.len(search)) == "$" then
			newsearch = string.sub(newsearch,1,string.len(newsearch)-1)
			ender = "$"
		end
        local numfound = 0
		if not string.find(search,"%(") then
		    if string.find(text,search) then
				numfound = 1
				table.insert(entries,true)
			end
		else
			while string.find(text,search) do				
				numfound = numfound + 1
				local found = {string.find(text,string.format("%s(%s)%s",starter,newsearch,ender))}
				local oldtext = text
				text = string.gsub(text,string.gsub(found[3],"(%p)","%%%1"),"",1)
				for id = 4,table.getn(found) do table.insert(entries,found[id]) end
				if text == oldtext then
					--something caused an infinite loop, oddly enough: thought id caught em all
					break
				end
			end
			if arg[i + 1] and numfound > 0 then
			    local numcaps = (table.getn(entries) - start + 1) / numfound
			    local numstart
				if arg[i + 1] < 0 then numstart = start elseif arg[i + 1] > 0 then numstart = start + (numcaps * arg[i + 1]) end
     			for id = 1,((numfound - math.abs(arg[i + 1])) * numcaps) do table.remove(entries,numstart) end
			end
		end
		if numfound == 0 then table.insert(entries,false) end
		start = table.getn(entries) + 1
		text = savetext
	end
	for index,value in entries do
		if type(tonumber(value)) == "number" then entries[index] = tonumber(value) end
	end
	return unpack(entries)
end

function DoTimer_Commands(msg,fromgui) --governs the /command
	if msg == "on" then 
		DoTimer_Settings.status = "on"
		DoTimer_AddMenuText("DoTimer by Asheyla now activated!",fromgui)
		DoTimerFrame:SetScript("OnEvent",function() DoTimer_OnEvent(event) end)
		DoTimerFrame:SetScript("OnUpdate",function() DoTimer_OnUpdate() end)
		DoTimerAnchorFrame:Show()
		DoTimer_Settings.visible = true		
	elseif msg == "off" then
		DoTimer_Settings.status = "off"
		DoTimer_AddMenuText("DoTimer by Asheyla is now deactivated.",fromgui)
		DoTimerFrame:SetScript("OnEvent",nil)
		DoTimerFrame:SetScript("OnUpdate",nil)
		DoTimerAnchorFrame:Hide()
		DoTimer_Settings.visible = false
	elseif msg == "debug off" then
		debugchannel = nil
		DoTimer_AddMenuText("No longer printing debug messages.",fromgui)
	elseif msg == "reset" then
		DoTimer_Settings = {}
		DoTimer_Startup()
		DoTimerMainFrame:ClearAllPoints()
		DoTimerMainFrame:SetPoint("CENTER","UIParent","CENTER")
		DoTimer_AddMenuText("All user data is now reset.",fromgui)
	elseif msg == "reset position" then
		DoTimerMainFrame:ClearAllPoints()
		DoTimerMainFrame:SetPoint("CENTER","UIParent","CENTER")
		DoTimer_AddMenuText("The position of the UI is now reset.",fromgui)		
	elseif msg == "ui off" then
		DoTimer_Settings.visible = false
		DoTimerAnchorFrame:Hide()
		DoTimer_AddMenuText("The interface is now hidden.",fromgui)
	elseif msg == "ui off" then
		DoTimer_Settings.visible = true
		DoTimerAnchorFrame:Show()
		DoTimer_AddMenuText("The interface is now shown.",fromgui)
	elseif msg == "names off" then
		DoTimer_Settings.names = false
		DoTimer_AddMenuText("Names will not be shown.",fromgui)
		DoTimer_ResizeInterface()
	elseif msg == "names on" then
		DoTimer_Settings.names = true
		DoTimer_AddMenuText("Names will  be shown.",fromgui)
		DoTimer_ResizeInterface()
	elseif msg == "mana check on" then
		DoTimer_Settings.manacheck = true
		DoTimer_AddMenuText("Life tap will be cast instead of the casted spell if not enough mana for it.",fromgui)
	elseif msg == "mana check off" then
		DoTimer_Settings.manacheck = false
		DoTimer_AddMenuText("Spell casts will behave normally.",fromgui)
	elseif msg == "lock" then
		DoTimer_Settings.locked = true
		DoTimerMainFrame:Hide()
		DoTimer_AddMenuText("The timers are now locked in place.",fromgui)
	elseif msg == "unlock" then
		DoTimer_Settings.locked = false
		DoTimerMainFrame:Show()
		DoTimer_AddMenuText("The timers can now be moved by dragging the little button around.",fromgui)
	elseif msg == "immol" then
		if preventingimmol then
			preventingimmol = nil
			DoTimer_AddMenuText("Immolate will be not anymore.")
		else
			preventingimmol = 1
			DoTimer_AddMenuText("Immolate will be prevented for the duration of combat.")
		end
	elseif msg == "hide" then
		DoTimer_DelTimers()
	elseif msg == "sort by remaining" then
		DoTimer_AddMenuText("Timers will now be ordered by their time remaining.",fromgui)
		DoTimer_Settings.sortbyadded = false
	elseif msg == "sort by added" then
		DoTimer_AddMenuText("Timers will now be ordered by when they were cast. ",fromgui)
		DoTimer_Settings.sortbyadded = true
	elseif msg == "clickable debuffs" then
		DoTimer_Settings.clickable = true
		for i = 1,10 do
			for id = 1,20 do
				getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTexture"):EnableMouse(true)
			end
		end	
		DoTimer_AddMenuText("The debuffs can now be clicked.  Shift+click to delete, click to target, control+click to create ghost timer.",fromgui)
	elseif msg == "unclickable debuffs" then
		for i = 1,10 do
			for id = 1,20 do
				getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTexture"):EnableMouse(false)
			end
		end	
		DoTimer_Settings.clickable = false
		DoTimer_AddMenuText("The debuffs can no longer be clicked.",fromgui)
	elseif msg == "no red text" then
		DoTimer_Settings.redtext = false
		DoTimer_AddMenuText("The timers will not change color.",fromgui)
	elseif msg == "red text" then
		DoTimer_Settings.redtext = true
		DoTimer_AddMenuText("The timers will change to red at 5 seconds.",fromgui)
	elseif msg == "show preventing immols" then
		DoTimer_AddText("The macro functions will prevent Immolate being cast on the following mobs: ")
		for index,value in DoTimer_Settings.preventimmol do DoTimer_AddText(index) end
	elseif msg == "old timers" then
		DoTimer_Settings.dep = true
		DoTimer_AddMenuText("Timers which may no longer be accurate for your current target will still be shown.",fromgui)
	elseif msg == "no old timers" then
		DoTimer_Settings.dep = false
		DoTimer_AddMenuText("Timers which may no longer be accurate for your current target will be deleted.",fromgui)
	elseif msg == "do not include probable" then
		DoTimer_Settings.probable = false
		DoTimer_AddMenuText("The macro functions scanning for your own debuffs will ignore depreciated timers.",fromgui)
	elseif msg == "include probable" then
		DoTimer_Settings.probable = true
		DoTimer_AddMenuText("The macro functions scanning for your own debuffs will include depreciated timers.",fromgui)
	elseif msg == "all ghost on" then
		DoTimer_Settings.allghost = true
		DoTimer_AddMenuText("Every timer created will automatically make a ghost timer.")
	elseif msg == "all ghost off" then
		DoTimer_Settings.allghost = false
		DoTimer_AddMenuText("Ghost timers will not be automatically created.")
	elseif msg == "status" then
		DoTimer_AddText("|cff00ffffDoTimer Status:|r")
		DoTimer_AddText("Status of addon: |cff00ff00"..tostring(DoTimer_Settings.status).."|r")
		DoTimer_AddText("UI scale: |cff00ff00"..tostring(DoTimer_Settings.scale).."|r")
		DoTimer_AddText("UI visible: |cff00ff00"..tostring(DoTimer_Settings.visible).."|r")
		DoTimer_AddText("showing names: |cff00ff00"..tostring(DoTimer_Settings.names).."|r")
		DoTimer_AddText("scan time: every |cff00ff00"..tostring(DoTimer_Settings.scantime).."|r seconds")
		DoTimer_AddText("checking for mana before spellcasts: |cff00ff00"..tostring(DoTimer_Settings.manacheck).."|r")
		DoTimer_AddText("max target tables: |cff00ff00"..tostring(DoTimer_Settings.maxtargets).."|r")
		DoTimer_AddText("max debuffs per target table: |cff00ff00"..tostring(DoTimer_Settings.maxdebuffs).."|r")
		DoTimer_AddText("locked timers in place: |cff00ff00"..tostring(DoTimer_Settings.locked).."|r")
		DoTimer_AddText("target expansion direction: |cff00ff00"..tostring(DoTimer_Settings.targetlayout).."|r")
		DoTimer_AddText("debuff expansion direction: |cff00ff00"..tostring(DoTimer_Settings.debufflayout).."|r")
		DoTimer_AddText("debuffs ordering by time added: |cff00ff00"..tostring(DoTimer_Settings.sortbyadded).."|r")
		DoTimer_AddText("clickable debuffs: |cff00ff00"..tostring(DoTimer_Settings.clickable).."|r")
		DoTimer_AddText("button scale: |cff00ff00"..tostring(DoTimer_Settings.buttonscale).."|r")
		DoTimer_AddText("changing color of timers: |cff00ff00"..tostring(DoTimer_Settings.redtext).."|r")
		DoTimer_AddText("showing depreciated timers: |cff00ff00"..tostring(DoTimer_Settings.dep).."|r")
		DoTimer_AddText("including probable timers in functions: |cff00ff00"..tostring(DoTimer_Settings.probable).."|r")
		DoTimer_AddText("mana check lifetap rank: |cff00ff00"..tostring(DoTimer_Settings.lifetaprank).."|r")
		DoTimer_AddText("automatic ghost timer creation: |cff00ff00"..tostring(DoTimer_Settings.allghost).."|r")
	elseif string.sub(msg,1,11) == "set layout " then
		local targetlayout,debufflayout = DoTimer_ParseString(msg,"(%a+)",-2)
		DoTimer_AddMenuText("Target tables will be added "..(targetlayout or "<cannot parse!>").." and debuffs will be added "..(debufflayout or "<cannot parse!>")..".",fromgui)
		DoTimer_DefineInterface(targetlayout,debufflayout)
	elseif string.sub(msg,1,4) == "show" then
		local num1,num2 = DoTimer_ParseString(msg,"(%d+)",2)
		DoTimer_AddTimers(num1,num2)
	elseif string.sub(msg,1,5) == "debug" then
		debugchannel = DoTimer_ParseString(msg,"(%d+)")
		if not debugchannel then debugchannel = "" end
		DoTimer_AddMenuText("Now printing debug messages.",fromgui)
	elseif string.sub(msg,1,5) == "scale" then
		local scale = tonumber(string.sub(msg,7))
		if type(scale) == "number" then 
			DoTimerAnchorFrame:SetScale(scale)
			DoTimer_Settings.scale = scale
			DoTimer_AddMenuText("New scale: "..scale)
			DoTimer_ResizeInterface()
		end
	elseif string.sub(msg,1,8) == "scantime" then
		local number = tonumber(string.sub(msg,10))
		if type(number) == "number" then
			DoTimer_Settings.scantime = number
			DoTimer_AddMenuText("A scan for updated timers will occur every "..number.." seconds.",fromgui)
		end
	elseif string.sub(msg,1,11) == "max targets" then
		local number = tonumber(string.sub(msg,13))
		if type(number) == "number" and number > 0 and number < 11 then
			DoTimer_Settings.maxtargets = number
			DoTimer_AddMenuText("Max number of target tables is now "..number,fromgui)
		end
	elseif string.sub(msg,1,9) == "simulate " then
		local spell,target = DoTimer_ParseString(msg,"simulate (.+) on (.+)")
		if spell and target and DoTimer_intable(spell,spells) then DoTimer_SimulateTimer(spell,target) end
	elseif string.sub(msg,1,11) == "max debuffs" then
		local number = tonumber(string.sub(msg,13))
		if type(number) == "number" and number > 0 and number < 21 then
			DoTimer_Settings.maxdebuffs = number
			DoTimer_AddMenuText("Max number of debuffs per target table is now "..number,fromgui)
		end
	elseif string.sub(msg,1,13) == "button scale " then
		local scale = tonumber(string.sub(msg,14))
		if type(scale) == "number" then 
			for i = 1,10 do
				for id = 1,20 do
					getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTexture"):SetScale(scale)
				end
			end
			DoTimer_Settings.buttonscale = scale
			DoTimer_AddMenuText("new button scale: "..scale,fromgui)
			DoTimer_ResizeInterface()
		end	
	elseif string.sub(msg,1,14) == "life tap rank " then
		local rank = string.sub(msg,15)
		if type(tonumber(rank)) == "number" or rank == "max" then
			DoTimer_Settings.lifetaprank = rank
			DoTimer_AddMenuText("The mana check feature will now use the following rank: "..rank,fromgui)
		end
	elseif string.sub(msg,1,17) == "prevent immol on " then
		local target = string.sub(msg,18)
		DoTimer_Settings.preventimmol[target] = 1
		DoTimer_AddMenuText("Macro functions will prevent Immolate being cast on "..target,fromgui)
	elseif string.sub(msg,1,19) == "unprevent immol on " then
		local target = string.sub(msg,20)
		DoTimer_Settings.preventimmol[target] = nil
		DoTimer_AddMenuText("Macro functions will not prevent Immolate being cast on"..target,fromgui)
	elseif string.sub(msg,1,4) == "help" then DoTimer_AddHelpMenu(msg)
	else
		DoTimer_AddMenuText("Type \"|cff00ff00/dotimer help|r\" for more options!",fromgui)
	end
end

function DoTimer_Startup() --called on first login per session, creates the default settings if needed or else just hides the interface and sets the scale
	loaded = 1
	if DoTimer_Settings.status == nil then 
		DoTimer_Settings.status = "on" 
		DoTimerMainFrameFirstUse:Show()
		DoTimerMainFrameFirstUse:SetText("<-- Welcome to DoTimer!  Please type \"/dotimer help new\" for first-time information.")
	end
	local _,classname = UnitClass("player")
	class = classname
	spells,petspells,healspells,enslavespells = DoTimer_DefineSpells(class)
	if DoTimer_Settings.scale == nil then DoTimer_Settings.scale = 1 end --setting the default settings
	if DoTimer_Settings.visible == nil then DoTimer_Settings.visible = true end
	if DoTimer_Settings.names == nil then DoTimer_Settings.names = true end
	if DoTimer_Settings.scantime == nil then DoTimer_Settings.scantime = .25 end
	if DoTimer_Settings.manacheck == nil then DoTimer_Settings.manacheck = false end
	if DoTimer_Settings.maxtargets == nil then DoTimer_Settings.maxtargets = 5 end
	if DoTimer_Settings.maxdebuffs == nil then DoTimer_Settings.maxdebuffs = 8 end
	if DoTimer_Settings.locked == nil then DoTimer_Settings.locked = false end
	if DoTimer_Settings.targetlayout == nil then DoTimer_Settings.targetlayout = "left" end
	if DoTimer_Settings.debufflayout == nil then DoTimer_Settings.debufflayout = "down" end
	if DoTimer_Settings.sortbyadded == nil then DoTimer_Settings.sortbyadded = true end
	if DoTimer_Settings.clickable == nil then DoTimer_Settings.clickable = true end
	if DoTimer_Settings.redtext == nil then DoTimer_Settings.redtext = true end
	if DoTimer_Settings.buttonscale == nil then DoTimer_Settings.buttonscale = 1 end
	if DoTimer_Settings.dep == nil then DoTimer_Settings.dep = true end
	if DoTimer_Settings.probable == nil then DoTimer_Settings.probable = true end
	if DoTimer_Settings.lifetaprank == nil then DoTimer_Settings.lifetaprank = "max" end
	if DoTimer_Settings.allghost == nil then DoTimer_Settings.allghost = false end
	if DoTimer_Settings.preventimmol == nil then DoTimer_Settings.preventimmol = { --the ones i can think of off the top of my head
		["Ragnaros"] = 1,
		["Onyxia"] = 1,
		["Nefarian"] = 1,
		["Ebonroc"] = 1,
		["Flamegor"] = 1,
		["Firemaw"] = 1,
		["Baron Geddon"] = 1,
		["Firelord"] = 1,
	} 
	end
	if not DoTimer_Settings.visible then DoTimerAnchorFrame:Hide() else DoTimerAnchorFrame:Show() end --obeying a couple  settings
	DoTimerAnchorFrame:SetScale(DoTimer_Settings.scale)
	for i = 1,10 do
		getglobal("DoTimerTarget"..i):Hide()
		for id = 1,20 do
			getglobal("DoTimerTarget"..i.."Debuff"..id):Hide()
			getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTexture"):EnableMouse(DoTimer_Settings.clickable)
			getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTexture"):SetScale(DoTimer_Settings.buttonscale)
		end
	end	
	if DoTimer_Settings.locked then DoTimerMainFrame:Hide() else DoTimerMainFrame:Show() end
	if DoTimer_Settings.status == "off" then
		DoTimerFrame:SetScript("OnEvent",nil)
		DoTimerFrame:SetScript("OnUpdate",nil)
	end
	DoTimer_DefineInterface(DoTimer_Settings.targetlayout,DoTimer_Settings.debufflayout,1)
end

function DoTimer_AddHelpMenu(msg) --the help menu displayed ingame
	if msg == "help general" then
		DoTimer_AddText("|cff00ffffDoTimer General Help:|r")
		DoTimer_AddText("|cff00ff00[on, off]|r: enables or disables the addon")
		DoTimer_AddText("|cff00ff00status|r: displays all the current settings")
		DoTimer_AddText("|cff00ff00ui [on, off]|r: toggles the graphical displaying of timers on/off, default on")
		DoTimer_AddText("|cff00ff00[un]lock|r: toggles the visibility of the dragging button, used to move around the timers, default shown")
	elseif msg == "help sizing" then
		DoTimer_AddText("|cff00ffffDoTimer Sizing Help:|r")
		DoTimer_AddText("|cff00ff00scale #|r: set UI scale to that number, default 1")
		DoTimer_AddText("|cff00ff00button scale #|r: set the button scale to that number, default 1")
	elseif msg == "help basic interface" then
		DoTimer_AddText("|cff00ffffDoTimer Basic Interface Help:|r")
		DoTimer_AddText("|cff00ff00names [on, off]|r: toggles the graphical displaying of the names of units who you have debuffed, default on")
		DoTimer_AddText("|cff00ff00max targets #|r: sets number of unique target tables created by the addon, max 10, default 5")
		DoTimer_AddText("|cff00ff00max debuffs #|r: sets number of debuffs per target table, max 20, default 8")
	elseif msg == "help advanced interface" then
		DoTimer_AddText("|cff00ffffDoTimer Advanced Interface Help:|r")
		DoTimer_AddText("|cff00ff00set layout [2 of: left,right,up,down]|r: sets the direction targets/debuffs expand, respectively, default \"left down\"")
		DoTimer_AddText("|cff00ff00show [#1 #2]|r: shows the interface for #1 targets and #2 debuffs, if not specified shows the max defined by your settings")
		DoTimer_AddText("|cff00ff00hide|r: hides all visible timers (note: used to hide those shown by previous command)")
		DoTimer_AddText("|cff00ff00sort by [added,remaining]|r: sorts the visible timers by either time added or time remaining, default added")
		DoTimer_AddText("|cff00ff00[no ]red text|r: determines if timers will turn red at 5 seconds, default on")
		DoTimer_AddText("|cff00ff00[un]clickable debuffs|r: determines if the debuff icons can be clicked (shiftclick to erase, click to target),default off")
		DoTimer_AddText("|cff00ff00[no ]old timers|r: determines if timers which may not be accurate for your current target will be shown (see help info), default on")
		DoTimer_AddText("|cff00ff00[do not ]include probable|r: determines if probable timers will be counted in the corresponding macro functions (see help info), default on")
	elseif msg == "help misc" then
		DoTimer_AddText("|cff00ffffDoTimer Misc Help:|r")
		DoTimer_AddText("|cff00ff00scantime #|r: sets how long the addon will wait to rescan the timers for updates (increase to improve performance, set to 0 for no delay), default .25")
		DoTimer_AddText("|cff00ff00mana check [on/off]|r: determines if Life Tap will be cast instead of the spell attempting to be cast if you don't have enough mana to cast it, default off")
		DoTimer_AddText("|cff00ff00simulate Spell on Target|r: creates a fake timer for Spell on Target (you must capitalize the spell correctly!)")
		DoTimer_AddText("|cff00ff00life tap rank [number or \"max\"]|r: sets the rank of Life Tap to use for the mana-check feature; max will cast the highest you have health for, default \"max\"")
		DoTimer_AddText("|cff00ff00prevent immol on mobname|r: makes macro functions DoT_IsSpell and DoT_IsPSpell not cast immolate on mobname")
		DoTimer_AddText("|cff00ff00unprevent immol on mobname|r: undoes what the above command did")
		DoTimer_AddText("|cff00ff00show preventing immols|r: shows all the mobs that immolate will be ignored on")
		DoTimer_AddText("|cff00ff00immol|r: toggles the preventing of immolate for duration of combat")
		DoTimer_AddText("|cff00ff00debug #}r: outputs debug messages to chat frame # (default shat frame if no number)")
		DoTimer_AddText("|cff00ff00debug off|r: turns off the debug messages")
		DoTimer_AddText("|cff00ff00all ghost [on,off]|r: determines if every created timer will automatically have a ghost timer created for it, default off")
	elseif msg == "help resetting" then
		DoTimer_AddText("|cff00ffffDoTimer Resetting Help:|r")
		DoTimer_AddText("|cff00ff00reset position|r: resets the position of the interface the the default middle of the screen")
		DoTimer_AddText("|cff00ff00reset|r: flushes all user data to create a brand new installation")
	elseif msg == "help version" then
		DoTimer_AddText("|cff00ffffDoTimer Version/Author Info:|r")
		DoTimer_AddText("|cff00ff00Current version|r: "..version)
		DoTimer_AddText("|cff00ff00Date Uploaded|r: "..date_uploaded)
		DoTimer_AddText("|cff00ff00Author|r: Asheyla <Warcraft Gaming Faction>, Shattered Hand (Horde)")
		DoTimer_AddText("|cff00ff00Contact info|r: ross456@gmail.com")
	elseif msg == "help info" then
		DoTimer_AddText("|cff00ffffDoTimer Information:|r")
		DoTimer_AddText("|cff00ff00Macro function DoT_IsPSpell(spell)|r: Tests your target for your own debuff.  If it cannot find it, casts it and returns false.  Else returns true.")
		DoTimer_AddText("|cff00ff00Macro function DoT_IsSpell(spell)|r: Tests your target for any of that debuff.  If it cannot find it, casts it and returns false.  Else returns true.")
		DoTimer_AddText("|cff00ff00Macro function DoT_DetermineCast(spell1,spell2)|r: If spell1 is not on target, casts it and returns false.  Else, if your own spell2 is not on target, casts it and returns false.  Else returns true.")
		DoTimer_AddText("|cff00ff00Macro function DoT_SpellOnTarget(spell)|r: Tests your target for any of that debuff.  If it cannot find it, return false.  Else returns true.  Does not cast.")
		DoTimer_AddText("|cff00ff00Macro function DoT_OwnSpellOnTarget(spell)|r: Tests your target for your own debuff.  If it cannot find it, return false.  Else returns true.  Does not cast.")
		DoTimer_AddText("|cff00ff00Macro function DoT_ReturnElapsed(spell)|r: Returns how long that spell has been on your target, or 0 if you don't have it on the mob.")
		DoTimer_AddText("|cff00ff00Macro function DoT_ReturnRemaining(spell)|r: Returns how much longer that spell will be on your target, or its max duration if you don't have it on the mob.")
		DoTimer_AddText("|cff00ff00Old timers|r: they appear as faded icons and are debuffs the addon deems inaccurate for whatever reason.  No functions interact with them; they are for your own benefit.")
		DoTimer_AddText("|cff00ff00Ghost timers|r: Made by control+clicking a timer.  When you click on them, it attempts to target the target of its originator debuff.  A subsequent click will cast the spell of the originator debuff.")
		DoTimer_AddText("|cff00ff00Including probable timers|r: If on, the macro functions that check for your own debuffs will also cycle through depreciated timers if it cannot find a suitable timer.  Good unless there are multiple warlocks fighting mobs.  Use wisely.")
	elseif msg == "help new" then
		DoTimer_AddText("|cff00ffffDoTimer Beginner's Guide:|r")
		DoTimer_AddText("|cff00ff00Please Note|r: The information in this subsection will not detail any other commands.  Please explore all help menus for a full understanding of all the features of this addon.")
		DoTimer_AddText("|cff00ff00First Installation|r: You will notice a small red box in the middle of your screen.  It is to this box that the timers are anchored.  Move it around by dragging it.  The text will go away once you begin moving it.")
		DoTimer_AddText("|cff00ff00DoTimers|r: When you go out into the world and DoT a mob, timers will automatically appear.  There is no configuration required for this basic step.")
		DoTimer_AddText("|cff00ff00Troubleshooting|r: If you ever have any errors, please contact me.  It would be best if you include a way to duplicate the problem.  Before doing this, try disabling your other addons and seeing if the problem goes away.  If it does, figure out the conflicting addon and tell me.")
		DoTimer_AddText("|cff00ff00Features|r: Many features of this addon have been direct requests by other players.  If you ever have any suggestions, feel free to contact me about them.")
	elseif msg == "help macros" then
		DoTimer_AddText("|cff00ffffDoTimer Example Macros:|r")
		DoTimer_AddText("|cff00ff00Cast your own corruption if it is not on the mob, else Shadow Bolt|r: /script if DoT_IsPSpell(\"Corruption\") then CastSpellByName(\"Shadow Bolt()\") end")
		DoTimer_AddText("|cff00ff00Cast own corruption / immolate, then Shadow Bolt|r: /script if DoT_IsPSpell(\"Corruption\") then if DoT_IsPSpell(\"Immolate\") then CastSpellByName(\"Shadow Bolt()\") end")
		DoTimer_AddText("|cff00ff00Cast Curse of Shadows if it is not on the mob, then Shoot wand|r: /script if DoT_IsSpell(\"Curse of Shadow\") then CastSpellByName(\"Shoot\") end")
		DoTimer_AddText("|cff00ff00Cast CoS, or if someone else did then CoA, then Corruption, then Shadow Bolt|r: /script if DoT_DetermineSpell(\"Curse of Shadow\",\"Curse of Agony\") then if DoT_IsPSpell(\"Corruption\") then CastSpellByName(\"Shadow Bolt()\") end end")
		DoTimer_AddText("|cff00ff00Cast Swiftmend if possible, else Rejuvenation|r: /script local s,c,r = DoT_SpellOnTarget,CastSpellByName,\"Rejuvenation\" if (s(r) or s(\"Regrowth\")) then c(\"Swiftmend\") else c(r) end")
	else
		DoTimer_AddText("|cff00ffffDoTimer Help Menu:|r")
		DoTimer_AddText("|cff00ff00help new|r: information for first-time users")
		DoTimer_AddText("|cff00ff00help general|r: basic addon features")
		DoTimer_AddText("|cff00ff00help sizing|r: changing the size of the interface")
		DoTimer_AddText("|cff00ff00help basic interface|r: controls for a few elements of the interface")
		DoTimer_AddText("|cff00ff00help advanced interface|r: more advanced options for the interface")
		DoTimer_AddText("|cff00ff00help misc|r: other random features")
		DoTimer_AddText("|cff00ff00help resetting|r: for resetting things")
		DoTimer_AddText("|cff00ff00help version|r: displays some version/author info")
		DoTimer_AddText("|cff00ff00help info|r: describes a few features of the addon")
		DoTimer_AddText("|cff00ff00help macros|r: displays a few example macros to get you started")
	end
end

-----------------------------------------------------------------------------------------------------------
-- ########### GENERAL TIMER FUNCTIONS ############### --
-----------------------------------------------------------------------------------------------------------

function DoTimer_ListDebuffs(unit) --creates a table of all the names of the debuffs on the unit
	if not unit then unit = "target" end
	local debuffs = {}
	local i = 1
	while UnitDebuff(unit,i) do
		DoTimerScanningFrame:ClearLines()
		DoTimerScanningFrame:SetUnitDebuff(unit,i)
		local spell = DoTimerScanningFrameTextLeft1:GetText()
		if spell then table.insert(debuffs,spell) end
		i = i + 1
	end
	i = 1
	while UnitBuff(unit,i) do
		DoTimerScanningFrame:ClearLines()
		DoTimerScanningFrame:SetUnitBuff(unit,i)
		local spell = DoTimerScanningFrameTextLeft1:GetText()
		if spell then table.insert(debuffs,spell) end
		i = i + 1
	end
	return debuffs
end

function DoTimer_ReturnTable(target,sex,level) --returns the timer table for the corresponding target/sex/level information
	local found
	for i = 1,table.getn(casted) do
		if casted[i].target == target and casted[i].sex == sex and casted[i].level == level then found = i end
	end
	return found
end

function DoTimer_ReturnNewDuration(time) --modifies the time remaining on the debuff into a format suitable for the screen
	local newtime = math.ceil(time)
	local minutes = math.floor(newtime / 60)
	local seconds = newtime - (60 * minutes)
	if seconds < 10 then seconds = tostring("0"..seconds) else seconds = tostring(seconds) end
	return string.format("%d:%s",minutes,seconds)
end 

function DoTimer_RemoveTimer(targetindex,debuffindex) --deletes a timer onscreen from existence
	table.remove(casted[targetindex],debuffindex)
	if table.getn(casted[targetindex]) == 0 then
		table.remove(casted,targetindex)
	end
	DoTimer_CreateInterface()
end

function DoTimer_ReturnTargetType(unit) --returns if that unit is a player or mob
	if not unit then unit = "target" end
	local name = UnitName(unit) 
	if not (string.find(name or ""," ")) and (UnitIsPlayer(unit) or UnitPlayerControlled(unit)) then return "player" end --making sure that any unit with  a space in its name is a mob, else returning player - includes pets as a player
	local type = UnitClassification(unit)
	if type == "worldboss" or type == "rare" or type == "rareelite" then return "specialmob" end --it is a mob, but we will never give it depreciated timers, since it is unique
	return "mob"
end

function DoTimer_CreateSpellTimer(spelltable) --creates a timer onscreen from nothingness
	--DoTimer_AddText(spell.." has been successfully cast on "..target..".")
	local list = {spell = spelltable.spell, rank = spelltable.rank, texture = spelltable.texture, duration = spelltable.duration, time = GetTime(), type = spelltable.timertype} --the table that governs debuff data
	local found = DoTimer_ReturnTable(spelltable.target,spelltable.targetsex,spelltable.targetlevel)
	--DEFAULT_CHAT_FRAME:AddMessage("number of tables: "..table.getn(casted))
	if not found then
		if table.getn(casted) == DoTimer_Settings.maxtargets then --deleting tables if over the  limit
			table.remove(casted,1) 
		end
		local newtableentry = {target = spelltable.target, type = spelltable.targettype, sex = spelltable.targetsex, level = spelltable.targetlevel} --making the new table for a new target
		table.insert(casted,newtableentry)
		found = table.getn(casted) 
	else
	end
	--DEFAULT_CHAT_FRAME:AddMessage("table for this target: "..found)
	--DEFAULT_CHAT_FRAME:AddMessage("number of entries in this table: "..table.getn(casted[found]))
	local spelltype
	if string.sub(spelltable.spell,1,5) == "Curse" then spelltype = 1 end
	if not (spelltable.timertype == "ghost" or spelltable.timertype == "fake") then
		for i = table.getn(casted[found]),1,-1 do --testing if any other spells need to be deleted: other curses, or other spells w/ same name (as in, user is refreshing a DoT)
			if ((casted[found][i].spell == spelltable.spell and not (casted[found].target == "Unknown")) or (string.sub(casted[found][i].spell,1,5) == "Curse" and spelltype)) and DoTimer_TimerIsReal(found,i) then
				--DEFAULT_CHAT_FRAME:AddMessage(casted[found][i].spell.." has been removed from "..target)
				table.remove(casted[found],i)
			end
		end
	end
	if table.getn(casted[found]) == DoTimer_Settings.maxdebuffs then --deleting any extra debuffs on target
		local ofound
		for i = 1,table.getn(casted[found]) do
			if casted[found][i].dep then
				table.remove(casted[found],i)
				ofound = 1
				break
			end
		end
		if not ofound then table.remove(casted[found],1) end
	end
	table.insert(casted[found],list) --adding the new debuff entry
	--DEFAULT_CHAT_FRAME:AddMessage("table number for this target: "..found)
	--DEFAULT_CHAT_FRAME:AddMessage("new size of this table: "..table.getn(casted[found]))
	--DEFAULT_CHAT_FRAME:AddMessage("new number of target tables: "..table.getn(casted))
	if DoTimer_Settings.allghost and DoTimer_TimerIsReal(found,table.getn(casted[found])) then DoTimer_CreateGhostTimer(found,table.getn(casted[found])) end
	DoTimer_CreateInterface() --draws the interface based on the variable command given, found = table that the debuff is going to
end

function DoTimer_OnUpdate() --updating the timers onscreen, as well as checking for any finished debuffs
	if not elapsed then elapsed = GetTime() end
	if GetTime() > elapsed + DoTimer_Settings.scantime then --to save resources, skips some onupdates
		local time = GetTime()
		elapsed = time
		for index,value in ipairs(casted) do --scanning all the debuffs to see if they are done
			for i = table.getn(casted[index]),1,-1 do
				if time >= casted[index][i].time + casted[index][i].duration then --yep it's done all right
					DoTimer_Debug(casted[index][i].spell.." has expired from the mob; full duration")
					DoTimer_RemoveTimer(index,i)
				else
					local remaining = math.ceil(casted[index][i].duration - time + casted[index][i].time) --modifying the displayed time if it needs changing
					if (not casted[index][i].displayed) or (remaining < casted[index][i].displayed) then
						getglobal("DoTimerTarget"..index.."Debuff"..i.."DisplayedTime"):SetText(DoTimer_ReturnNewDuration(remaining)) --updating the time if they aren't done
						if remaining <= 5.1 and remaining >= 4.9 and DoTimer_Settings.redtext and (not (casted[index][i].type == "ghost")) then getglobal("DoTimerTarget"..index.."Debuff"..i.."DisplayedTime"):SetTextColor(1,.2,.2) end
						casted[index][i].displayed = remaining
					end
				end
			end
		end
		DoTimer_ScanCurrentEntries() --seeing if anything has faded unexpectedly
	end
end

function DoTimer_ScanCurrentEntries() --deletes the timers of spells which are no longer on the target
	local unitids = {"target","pettarget"} --making use of both your target and your pet's target
	for index,value in unitids do
		local target,sex,level,debuffs
		target = UnitName(value)
		sex = UnitSex(value)
		level = UnitLevel(value)
		debuffs = DoTimer_ListDebuffs(value)
		local found = DoTimer_ReturnTable(target,sex,level)
		if found then
			for i = table.getn(casted[found]),1,-1 do
				local spellname = casted[found][i].spell
				local ontarget
				if DoTimer_ReturnEnglish(spellname) == "Spell Lock" then ontarget = 1 end --we will not delete spell lock
				for ind,val in debuffs do
					if spellname == val then ontarget = 1 end --a debuff found on the mob matches the query
				end
				if not DoTimer_TimerIsAppreciated(found,i) then ontarget = 1 end --we only want to deal with appreciated timers
				if not ontarget then
					local wrongreason -- if a new curse or a refresh, the timer will disappear before the other code adds it.  in this case we want to delete, not depreciate
					local tables = {incomginspell, sentspell, finalspell}
					for index,value in tables do
						for id = table.getn(value),1,-1 do
							if (value[id].target == target and value[id].targetsex == sex and value[id].targetlevel == level) and ((value[id].spell == spellname) or string.sub(spellname,1,5) == "Curse" and string.sub(value[id].spell,1,5) == "Curse") then wrongreason = 1 end
						end
					end
					if not wrongreason then
						DoTimer_Debug(casted[found][i].spell.." not found on target; depreciating if mob, deleting if not")
						if casted[found].type == "mob" then DoTimer_DepreciateTimer(found,i) else DoTimer_RemoveTimer(found,i) end --player timers are removed because they cannot be depreciated
					else
						DoTimer_Debug(casted[found][i].spell.." not found on target, but we expected that")
						DoTimer_RemoveTimer(found,i)
					end
				end
			end
		end
	end
end

function DoTimer_DepreciateTimer(found,i) --depreciated the timer if the target is eligible
	--if casted[found].eligible then DoTimer_AddText("The timers for "..casted[found].target.." are eligible for depreciation.") else DoTimer_AddText("The timers for "..casted[found].target.." are not eligible for depreciation.") end
	if DoTimer_Settings.dep and (casted[found].eligible) and ((casted[found][i].displayed or 2) > 1) then
		casted[found][i].dep = 1
		casted[found][i].depstart = GetTime()
		DoTimer_CreateInterface()
	else
		DoTimer_RemoveTimer(found,i)
	end
end

function DoTimer_TimerIsAppreciated(targetindex,debuffindex) --will return true if the debuff is not depreciated, a ghost timer, a simulated timer, or a beneficial timer, or enslave
	--if (not casted[targetindex][debuffindex].dep) and (not casted[targetindex][debuffindex].ghost) and (not casted[targetindex][debuffindex].fake) and (not casted[targetindex][debuffindex].heal) then return true end
	local type = casted[targetindex][debuffindex].type
	if (not casted[targetindex][debuffindex].dep) and (type == "debuff" or type == "pet") then return true end
	return false
end

function DoTimer_TimerIsReal(targetindex,debuffindex) --will return true if not dep. and either a debuff/pet/heal/enslave timer (no ghost or fake)
	local type = casted[targetindex][debuffindex].type
	if (not casted[targetindex][debuffindex].dep) and (type == "debuff" or type == "heal" or type == "pet" or type == "enslave") then return true end
	return false
end

function DoTimer_intable(query,checkedtable) --checks a spell to see if it needs to be watched (as in, it was in that big spell list at the top)
	return checkedtable[DoTimer_ReturnEnglish(query)] --used to be longer, but code changes made it simpler.  dont feel like replacing it in the code, so it's here to stay
end

function DoTimer_ReturnCastTime(spellname,rankname) --returns the casting length of a spell so that we only look at a SPELLCAST_STOP for it actually casting, since it is also called for an interrupt
	local tables = {BOOKTYPE_SPELL,BOOKTYPE_PET}
	for index,value in tables do
		local i = 1
		local found
		while GetSpellName(i,value) do --figuring out which spell it is in spellbook
			local spell,rank = GetSpellName(i,value)
			if spell == spellname and ((rank == rankname) or (rankname == "no rank!") or (value == BOOKTYPE_PET)) then
				found = i
				break
			end
			i = i + 1
		end
		if found then
			DoTimerScanningFrame:ClearLines() --parsing the cast time
			DoTimerScanningFrame:SetSpell(found,value)
			local casttime = DoTimer_ParseString(DoTimerScanningFrameTextLeft3:GetText(),"^(%d[%d%.]*) ")
			return (casttime or 0) --if it couldn't find one, it assumes instant cast
		end
	end
end

function DoTimer_ReturnDuration(spell,rank) --returns the duration of a spell
	local tables = {BOOKTYPE_SPELL,BOOKTYPE_PET}
	for index,value in tables do
		local i = 1
		while GetSpellName(i,value) do
			local spellname,spellrank = GetSpellName(i,value)
			if spellname == spell and ((spellrank == rank) or (rank == "no rank!") or (value == BOOKTYPE_PET)) then
				DoTimerScanningFrame:ClearLines()
				DoTimerScanningFrame:SetSpell(i,value)
				local num = DoTimerScanningFrame:NumLines()
				local text = getglobal("DoTimerScanningFrameTextLeft"..num):GetText()
				local allnumbers = {DoTimer_ParseString(text,"(%d[%d%.]*)")}
				local basenumber = DoTimer_SpellData[class][DoTimer_ReturnTexture(spell)].duration
				local multiplier = DoTimer_SpellData[class][DoTimer_ReturnTexture(spell)].multiplier
				local truenumber
				for index2,value2 in allnumbers do
					if ((not truenumber) or (math.abs(value2 - basenumber) < math.abs(truenumber - basenumber))) then truenumber = value2 end
				end
				return truenumber * multiplier
			end
			i = i + 1
		end
	end
end

function DoTimer_ReturnTexture(spell) --returns the texture path for the icon of the spell
	local tables = {BOOKTYPE_SPELL,BOOKTYPE_PET}
	for index,value in tables do
		local i = 1
		while GetSpellName(i,value) do
			local spellname = GetSpellName(i,value)
			if spell == spellname then 
				return GetSpellTexture(i,value)
			end
			i = i + 1
		end
	end
end 

function DoTimer_CheckPreTimers() --checks all my queues to see if anything can be weeded out
	for i = table.getn(incomingspell),1,-1 do
		if GetTime() >= incomingspell[i].timestart + incomingspell[i].casttime + 3 then
			DoTimer_Debug("removed "..incomingspell[i].spell.." from incomingspell; took too long")
			table.remove(incomingspell,i) 
			if (table.getn(incomingspell) > 0 or table.getn(sentspell) > 0) then watchedspell = 1 else watchedspell = nil end
		end
	end
	for i = table.getn(finalspell),1,-1 do
		if GetTime() >= finalspell[i].timestart + 1 then 
			DoTimer_Debug("removed "..finalspell[i].spell.." from finalspell; took too long")
			table.remove(finalspell,i) 
		end
	end
	for i = table.getn(finalpetspell),1,-1 do
		if GetTime() >= finalpetspell[i].timestart + 3 then 
			DoTimer_Debug("removing "..finalpetspell[i].spell.." from finalpetspell; took too long")
			table.remove(finalpetspell,i) 
		end
	end
	for i = table.getn(castenslavespell),1,-1 do
		if GetTime() >= castenslavespell[i].timestart + castenslavespell[i].casttime + 5 then 
			DoTimer_Debug("removing "..castenslavespell[i].spell.." from castenslavespell; took too long")
			table.remove(castenslavespell,i) 
			if table.getn(castenslavespell) > 0 then watchedenslave = 1 else watchedenslave = nil end
		end
	end
	if table.getn(incomingspell) + table.getn(finalspell) + table.getn(finalpetspell) + table.getn(castenslavespell) == 0 then DoTimerPreTimerFrame:SetScript("OnUpdate",nil) end
end

------------------------------------------------------------------------------------------------------------
-- ################ FUNCTION HOOKS ################# --
------------------------------------------------------------------------------------------------------------

Old_CSBN = CastSpellByName
function DoTimer_CSBN(cspell,onself) --the CastSpellByName hook (mostly from macros)
	DoTimer_Debug("CastSpellByName")
	if DoTimer_Settings.status == "on" then
		if table.getn(casthealspell) > 0 then watchedheal = 1 else watchedheal = nil end
		if (table.getn(incomingspell) > 0 or table.getn(sentspell) > 0) then watchedspell = 1 else watchedspell = nil end
		local spellname,spellrank = DoTimer_ParseString(cspell,"(.+%a).*%((.*)%)")
		if not spellname then
			spellname = cspell
			spellrank = ""
		end
		DoTimer_Debug(spellname)
		local spelltype = DoTimer_ReturnSpellType(spellname)
		if spelltype == "player" then
			if spellrank == "" then spellrank = DoTimer_ReturnRank(spellname) end
			if (not DoTimer_Settings.manacheck) or (DoTimer_EnoughMana(spellname,spellrank)) then
				if DoTimer_intable(spellname,spells) then 
					DoTimer_Debug("initiating timer for "..spellname)
					DoTimer_InitiateSpellTimer(spellname,spellrank) 
					Old_CSBN(cspell,onself)
				elseif DoTimer_intable(spellname,healspells) then 
					spelltargeted = nil
					Old_CSBN(cspell,onself)
					if not onself then
						if SpellIsTargeting() then
							DoTimer_Debug("initiating timer for "..spellname)
							DoTimer_InitiateHealSpellTimer(spellname,spellrank) 
						else
							local unit
							if UnitExists("target") then unit = "target" end
							if spelltargeted then 
								if (spelltargeted == "stopped") or (spelltargeted == "player") then unit = nil else unit = spelltargeted end
							end
							if unit then
								DoTimer_Debug("creating timer for "..spellname)
								local timestart,texture,duration,casttime,target,targetsex,targetlevel,targettype
								timestart = GetTime()
								target = UnitName(unit)
								targetsex = UnitSex(unit)
								targetlevel = UnitLevel(unit)
								targettype = DoTimer_ReturnTargetType(unit)
								texture,duration,casttime = DoTimer_ReturnInfo(spellname,spellrank)
								local healentry = {spell = spellname, rank = spellrank, timestart = timestart, texture = texture, duration = duration, casttime = casttime, target = target, targetsex = targetsex, targetlevel = targetlevel, targettype = targettype, timertype = "heal"}
								DoTimer_CreateSpellTimer(healentry)
							end
						end	
					end
				elseif DoTimer_intable(spellname,enslavespells) then
					DoTimer_Debug("initiating timer for "..spellname)
					DoTimer_InitiateEnslaveSpellTimer(spellname,spellrank) 
					Old_CSBN(cspell,onself)
				else
					Old_CSBN(cspell,onself)
				end
			end
		else
			Old_CSBN(cspell,onself)
		end
	else
		Old_CSBN(cspell,onself)
	end
end
CastSpellByName = DoTimer_CSBN

Old_CS = CastSpell
function DoTimer_CS(cspell,booktype) --the CastSpell hook (clicking on a spell from spellbook)
	DoTimer_Debug("CastSpell")
	if DoTimer_Settings.status == "on" then
		if table.getn(casthealspell) > 0 then watchedheal = 1 else watchedheal = nil end
		if (table.getn(incomingspell) > 0 or table.getn(sentspell) > 0) then watchedspell = 1 else watchedspell = nil end
		local spellname,spellrank = GetSpellName(cspell,booktype)
		local spelltype
		if booktype == BOOKTYPE_PET then spelltype = "pet" else spelltype = "player" end
		DoTimer_Debug(spellname)
		if spelltype == "player" then
			if (spellrank == nil or spellrank == "") then spellrank = "no rank!" end
			if (not DoTimer_Settings.manacheck) or (DoTimer_EnoughMana(spellname,spellrank)) then
				if DoTimer_intable(spellname,spells) then 
					DoTimer_Debug("initiating timer for "..spellname)
					DoTimer_InitiateSpellTimer(spellname,spellrank) 
					Old_CS(cspell,booktype)
				elseif DoTimer_intable(spellname,healspells) then 
					spelltargeted = nil
					Old_CS(cspell,booktype)
					if SpellIsTargeting() then
						DoTimer_Debug("initiating timer for "..spellname)
						DoTimer_InitiateHealSpellTimer(spellname,spellrank) 
					else
						local unit
						if UnitExists("target") then unit = "target" end
						if spelltargeted then 
							if (spelltargeted == "stopped") or (spelltargeted == "player") then unit = nil else unit = spelltargeted end
						end
						if unit then
							DoTimer_Debug("creating timer for "..spellname)
							local timestart,texture,duration,casttime,target,targetsex,targetlevel,targettype
							timestart = GetTime()
							target = UnitName(unit)
							targetsex = UnitSex(unit)
							targetlevel = UnitLevel(unit)
							targettype = DoTimer_ReturnTargetType(unit)
							texture,duration,casttime = DoTimer_ReturnInfo(spellname,spellrank)
							local healentry = {spell = spellname, rank = spellrank, timestart = timestart, texture = texture, duration = duration, casttime = casttime, target = target, targetsex = targetsex, targetlevel = targetlevel, targettype = targettype, timertype = "heal"}
							DoTimer_CreateSpellTimer(healentry)
						end
					end	
				elseif DoTimer_intable(spellname,enslavespells) then
					DoTimer_Debug("initiating timer for "..spellname)
					DoTimer_InitiateEnslaveSpellTimer(spellname,spellrank) 
					Old_CS(cspell,booktype)
				else
					Old_CS(cspell,booktype)
				end
			end
		else
			Old_CS(cspell,booktype)
		end
	else
		Old_CS(cspell,booktype)
	end
end
CastSpell = DoTimer_CS

Old_UA = UseAction
function DoTimer_UA(cspell,cursor,onself) --the UseAction hook (clicking on an action button/using its hotkey)
	DoTimer_Debug("UseAction")
	if DoTimer_Settings.status == "on" then
		if table.getn(casthealspell) > 0 then watchedheal = 1 else watchedheal = nil end
		if (table.getn(incomingspell) > 0 or table.getn(sentspell) > 0) then watchedspell = 1 else watchedspell = nil end
		local type
		if GetActionText(cspell) then elseif GetActionCount(cspell) > 0 then else type = 1 end
		if type then
			local spellname,spellrank = DoTimer_SetAction(cspell)
			DoTimer_Debug(spellname)
			if (not DoTimer_Settings.manacheck) or (DoTimer_EnoughMana(spellname,spellrank)) then
				if DoTimer_intable(spellname,spells) then 
					DoTimer_Debug("initiating timer for "..spellname)
					DoTimer_InitiateSpellTimer(spellname,spellrank) 
					Old_UA(cspell,cursor,onself)
				elseif DoTimer_intable(spellname,healspells) then 
					spelltargeted = nil
					Old_UA(cspell,cursor,onself)
					if not onself then
						if SpellIsTargeting() then
							DoTimer_Debug("initiating timer for "..spellname)
							DoTimer_InitiateHealSpellTimer(spellname,spellrank) 
						else
							local unit
							if UnitExists("target") then unit = "target" end
							if spelltargeted then 
								if (spelltargeted == "stopped") or (spelltargeted == "player") then unit = nil else unit = spelltargeted end
							end
							if unit then
								DoTimer_Debug("creating timer for "..spellname)
								local timestart,texture,duration,casttime,target,targetsex,targetlevel,targettype
								timestart = GetTime()
								target = UnitName(unit)
								targetsex = UnitSex(unit)
								targetlevel = UnitLevel(unit)
								targettype = DoTimer_ReturnTargetType(unit)
								texture,duration,casttime = DoTimer_ReturnInfo(spellname,spellrank)
								local healentry = {spell = spellname, rank = spellrank, timestart = timestart, texture = texture, duration = duration, casttime = casttime, target = target, targetsex = targetsex, targetlevel = targetlevel, targettype = targettype, timertype = "heal"}
								DoTimer_CreateSpellTimer(healentry)
							end
						end						
					end
				elseif DoTimer_intable(spellname,enslavespells) then
					DoTimer_Debug("initiating timer for "..spellname)
					DoTimer_InitiateEnslaveSpellTimer(spellname,spellrank) 
					Old_UA(cspell,cursor,onself)
				else
					Old_UA(cspell,cursor,onself)
				end
			end
		else
			Old_UA(cspell,cursor,onself)
		end
	else
		Old_UA(cspell,cursor,onself)
	end
end
UseAction = DoTimer_UA

function DoTimer_OnWorldClick() --when the mouse is pressed with the worldframe having focus
	if watchedheal and (SpellCanTargetUnit("mouseover") or not SpellIsTargeting()) then
		DoTimer_Debug("world clicked")
		if UnitIsUnit("mouseover","player") then
			DoTimer_Debug("clicked self")
			for i = table.getn(casthealspell),1,-1 do
				if not casthealspell[i].target then 
					DoTimer_Debug("removed "..casthealspell[i].spell)
					table.remove(casthealspell,i)
					if table.getn(casthealspell) > 0 then watchedheal = 1 else watchedheal = nil end
					break
				end
			end
		else
			DoTimer_Debug("clicked someone else")
			for i = table.getn(casthealspell),1,-1 do
				if not casthealspell[i].target then
					casthealspell[i].target = UnitName("mouseover")
					casthealspell[i].targetsex = UnitSex("mouseover")
					casthealspell[i].targetlevel = UnitLevel("mouseover")
					break
				end
			end
		end
	end
end

Old_TU = TargetUnit
function DoTimer_TU(unit) --the TargetUnit hook (targetting a unit)
	DoTimer_Debug("TargetUnit")
	spelltargeted = unit
	if watchedheal and SpellCanTargetUnit(unit) then
		if unit == "player" then
			DoTimer_Debug("targeted self")
			for i = table.getn(casthealspell),1,-1 do
				if not casthealspell[i].target then 
					DoTimer_Debug("removed "..casthealspell[i].spell)
					table.remove(casthealspell,i)
					if table.getn(casthealspell) > 0 then watchedheal = 1 else watchedheal = nil end
					break
				end
			end
		else
			DoTimer_Debug("targeted someone else")
			for i = table.getn(casthealspell),1,-1 do
				if not casthealspell[i].target then
					casthealspell[i].target = UnitName(unit)
					casthealspell[i].targetsex = UnitSex(unit)
					casthealspell[i].targetlevel = UnitLevel(unit)
					break
				end
			end
		end
	end
	Old_TU(unit)
end
TargetUnit = DoTimer_TU

Old_STU = SpellTargetUnit
function DoTimer_STU(unit) --the SpellTargetUnit hook (telling the spell awaiting a target who to target)
	DoTimer_Debug("SpellTargetUnit")
	spelltargeted = unit
	if watchedheal and SpellCanTargetUnit(unit) then
		if unit == "player" then
			DoTimer_Debug("targeted self")
			for i = table.getn(casthealspell),1,-1 do
				if not casthealspell[i].target then 
					DoTimer_Debug("removed "..casthealspell[i].spell)
					table.remove(casthealspell,i)
					if table.getn(casthealspell) > 0 then watchedheal = 1 else watchedheal = nil end
					break
				end
			end
		else
			DoTimer_Debug("targeted someone else")
			for i = table.getn(casthealspell),1,-1 do
				if not casthealspell[i].target then
					casthealspell[i].target = UnitName(unit)
					casthealspell[i].targetsex = UnitSex(unit)
					casthealspell[i].targetlevel = UnitLevel(unit)
					break
				end
			end
		end
	end
	Old_STU(unit)
end
SpellTargetUnit = DoTimer_STU

Old_SST = SpellStopTargeting
function DoTimer_SST() --the SpellStopTargeting hook (to cancel a spell awaiting a target)
	DoTimer_Debug("SpellStopTargeting")
	spelltargeted = "stopped"
	if watchedheal then
		for i = table.getn(casthealspell),1,-1 do
			if not casthealspell[i].target then
				DoTimer_Debug("removed "..casthealspell[i].spell)
				table.remove(casthealspell,i)
				if table.getn(casthealspell) > 0 then watchedheal = 1 else watchedheal = nil end
				break
			end
		end
	end
	Old_SST()
end
SpellStopTargeting = DoTimer_SST

------------------------------------------------------------------------------------------------------------
-- ############## PLAYER TIMER FUNCTIONS ############## --
------------------------------------------------------------------------------------------------------------

function DoTimer_InitiateSpellTimer(spell,rank) --begins the process of making a timer onscreen
	local targettype,target,timestart,targetsex,targetlevel,texture,duration,casttime
	targettype = DoTimer_ReturnTargetType("target")
	target = (UnitName("target") or "Unknown")
	timestart = GetTime()
	targetsex = (UnitSex("target") or 0)
	targetlevel = (UnitLevel("target") or 60)
	texture,duration,casttime = DoTimer_ReturnInfo(spell,rank)
	local incomingspellentry = {
		spell = spell, rank = rank, target = target, timestart = timestart, targetsex = targetsex, targetlevel = targetlevel, texture = texture, duration = duration, casttime = casttime, targettype = targettype, timertype = "debuff"
	}
	table.insert(incomingspell,incomingspellentry)
	if table.getn(incomingspell) == 1 then DoTimerPreTimerFrame:SetScript("OnUpdate",function() DoTimer_CheckPreTimers() end) end
	if (table.getn(incomingspell) > 0 or table.getn(sentspell) > 0) then watchedspell = 1 else watchedspell = nil end
end

function DoTimer_InitiateEnslaveSpellTimer(spell,rank) --begins the process of making an enslave timer.  itll be applied when our pet changes
	local timestart,texture,duration,casttime
	timestart = GetTime()
	texture,duration,casttime = DoTimer_ReturnInfo(spell,rank)
	local enslaveentry = {spell = spell, rank = rank, timestart = timestart, texture = texture, duration = duration, casttime = casttime, timertype = "enslave"}
	table.insert(castenslavespell,enslaveentry)
	if table.getn(castenslavespell) == 1 then DoTimerPreTimerFrame:SetScript("OnUpdate",function() DoTimer_CheckPreTimers() end) end
	if table.getn(castenslavespell) > 0 then watchedenslave = 1 else watchedenslave = nil end
end

function DoTimer_InitiateHealSpellTimer(spell,rank) --begins the process of making a healing timer.  basically same as harmful spells, but target data is not parsed yet
	local timestart,texture,duration,casttime
	timestart = GetTime()
	texture,duration,casttime = DoTimer_ReturnInfo(spell,rank)
	local healentry = {spell = spell, rank = rank, timestart = timestart, texture = texture, duration = duration, casttime = casttime, timertype = "heal"}
	table.insert(casthealspell,healentry)
	if table.getn(casthealspell) > 0 then watchedheal = 1 else watchedheal = nil end
end

function DoTimer_EnoughMana(spellname,rankname) --detects if you have enough mana for the attempted spell before you actually cast it
	if DoTimer_ReturnEnglish(spellname) == "Life Tap" then return true end
	local mana = DoTimer_ReturnManaCost(spellname,rankname)
	if not mana or mana < UnitMana("player") then return true end
	if DoTimer_Settings.lifetaprank == "max" then
		CastSpellByName(DoTimer_ToLocale("Life Tap"))
	else
		local i = 1
		while GetSpellName(i,BOOKTYPE_SPELL) do 
			local spell,rank = GetSpellName(i,BOOKTYPE_SPELL)
			local ranknum = DoTimer_ParseString(rank,"(%d+)")
			if spell == DoTimer_ToLocale("Life Tap") and ranknum == DoTimer_Settings.lifetaprank then 
				CastSpell(i,BOOKTYPE_SPELL)
				break
			end
			i = i + 1
		end
	end
	return false
end

function DoTimer_ReturnManaCost(spellname,rankname) --parsing the mana cost of the spell
	local i = 1
	local found
	while GetSpellName(i,BOOKTYPE_SPELL) do
		local spell,rank = GetSpellName(i,BOOKTYPE_SPELL)
		if spell == spellname and ((rank == rankname) or (rankname == "no rank!")) then
			found = i
			break
		end
		i = i + 1
	end
	if found then
		--DoTimer_AddText("spell found at "..found)
		DoTimerScanningFrame:ClearLines()
		DoTimerScanningFrame:SetSpell(found,"spell")
		local mana = DoTimer_ParseString(DoTimerScanningFrameTextLeft2:GetText(),"^(%d+) ")
		--DoTimer_AddText("mana: "..UnitMana("player")..", needed: "..mana)
		return (mana or false)
	else
		--DoTimer_AddText("cant find spell")
		return false
	end
end

function DoTimer_ReturnSpellType(spellname) --determining if the player or pet cast the spell
	local spelltype
	local i = 1
	while GetSpellName(i,BOOKTYPE_SPELL) do
		local spell = GetSpellName(i,BOOKTYPE_SPELL)
		if spell == spellname then 
			spelltype = "player"
			break 
		end
		i = i + 1
	end
	if not spelltype then
		local i = 1
		while GetSpellName(i,BOOKTYPE_PET) do
			local spell = GetSpellName(i,BOOKTYPE_PET)
			if spell == spellname then 
				spelltype = "pet"
				break 
			end
			i = i + 1
		end
	end
	if not spelltype then spelltype = "unknown" end
	return spelltype
end

function DoTimer_SetAction(id) --used to parse information about a spell for UseAction
	DoTimerScanningFrame:ClearLines()
	DoTimerScanningFrameTextRight1:SetText("")
	DoTimerScanningFrame:SetAction(id)
	local spellname = DoTimerScanningFrameTextLeft1:GetText()
	local spellrank = (DoTimerScanningFrameTextRight1:GetText() or "")
	if not spellrank == "" then spellrank = "no rank!" end
	return spellname,spellrank
end

function DoTimer_ReturnRank(spell) --called if the spell did not have a rank from CastSpellByName, returns highest rank
	local highrank
	local i = 1
	while GetSpellName(i,BOOKTYPE_SPELL) do
		local spellname,spellrank = GetSpellName(i,BOOKTYPE_SPELL)
		if spellname == spell then highrank = spellrank end
		i = i + 1
	end
	if (highrank == nil) or (highrank == "") then highrank = "no rank!" end
	return highrank
end

function DoTimer_ReturnInfo(spell,rank) --used to be longer; i used to save the data in tables, but due to the fact that this data sometimes changes and not b/c of talents, im gonna parse it every time
	return DoTimer_ReturnTexture(spell),DoTimer_ReturnDuration(spell,rank),DoTimer_ReturnCastTime(spell,rank)
end 

function DoTimer_AwaitIcon() --the final stage for a timer; waiting for your target to actually have the debuff on it
	local debuffs = DoTimer_ListDebuffs()
	for i = table.getn(finalspell),1,-1 do
		local found
		if not (finalspell[i].target == UnitName("target") and finalspell[i].targetsex == UnitSex("target") and finalspell[i].targetlevel == UnitLevel("target")) then 
			found = 1
		else
			for index,value in debuffs do
				if finalspell[i].spell == value then
					found = 1
					break
				end
			end
		end
		if found then
			DoTimer_Debug("creating a timer for "..finalspell[i].spell)
			DoTimer_CreateSpellTimer(finalspell[i])
			table.remove(finalspell,i)
		end
	end
	if table.getn(finalspell) == 0 then DoTimerIconFrame:SetScript("OnUpdate",nil) end
end

function DoTimer_DelayTimer() --the final function before creating a spell timer.  delays the timer .3 seconds if made from SPELLCAST_STOP, to account for waiting for a resist message.  no delay for UNIT_MANA
	local time = GetTime()
	for i = table.getn(sentspell),1,-1 do
		if time >= sentspell[i].timestart + sentspell[i].casttime then
			--DoTimer_CreateSpellTimer(sentspell[i])
			DoTimer_Debug("passing "..sentspell[i].spell.." to finalspell")
			local finalspellentry = {}
			for index,value in sentspell[i] do finalspellentry[index] = value end
			finalspellentry.timestart = GetTime()
			table.insert(finalspell,finalspellentry)
			if table.getn(finalspell) == 1 then 
				DoTimerPreTimerFrame:SetScript("OnUpdate",function() DoTimer_CheckPreTimers() end)
				DoTimerIconFrame:SetScript("OnUpdate",function() DoTimer_AwaitIcon() end) 
			end
			table.remove(sentspell,i)
			if table.getn(sentspell) == 0 then DoTimerDelayFrame:SetScript("OnUpdate",nil) end
		end
	end
end

------------------------------------------------------------------------------------------------------------
-- ############### PET TIMER FUNCTIONS ############### --
------------------------------------------------------------------------------------------------------------
	
function DoTimer_InitiatePetSpellTimer(spell) --begins the process of making a pet timer onscreen
	local timestart,texture,duration,casttime
	timestart = GetTime()
	texture,duration,casttime = DoTimer_ReturnPetInfo(spell)
	local unit = "target"
	if UnitExists("pettarget") then unit = "pettarget" end
	local target = (UnitName(unit) or "Unknown")
	local targetsex = (UnitSex(unit) or 0)
	local targettype = DoTimer_ReturnTargetType(unit)
	local targetlevel = (UnitLevel(unit) or 60)
	local entry = {spell = spell, timestart = timestart, texture = texture, duration = duration, casttime = casttime, target = target, targetsex = targetsex, targettype = targettype, targetlevel = targetlevel, unit = unit, timertype = "pet"}
	table.insert(castpetspell,entry)
	if table.getn(castpetspell) == 1 then 
		DoTimerPetFrame:SetScript("OnUpdate",function() DoTimer_AwaitPetCast() end) 
	end
end

function DoTimer_AwaitPetCast()
	--delays the pet timers an amount of time = to casttime, then sends to sentpetspell
	for i = table.getn(castpetspell),1,-1 do
		if (GetTime() >= castpetspell[i].timestart + castpetspell[i].casttime) then
			DoTimer_Debug("sending "..castpetspell[i].spell.." to sentpetspell")
			local sentpetspellentry = {} --now this spell will wait .5 seconds for interrupts, resists, immunes, etc.
			for index,value in castpetspell[i] do sentpetspellentry[index] = value end
			sentpetspellentry.casttime = .5
			sentpetspellentry.timestart = GetTime()
			table.remove(castpetspell,i)
			table.insert(sentpetspell,sentpetspellentry)
			if table.getn(sentpetspell) == 1 then DoTimerPetDelayFrame:SetScript("OnUpdate",function() DoTimer_DelayPetTimer() end) end
			if table.getn(castpetspell) == 0 then DoTimerPetFrame:SetScript("OnUpdate",nil) end
		end
	end
end

function DoTimer_DelayPetTimer()
	--delays the pet timers .5 seconds to wait for resists or whatever, then sends to finalpetspell
	local time = GetTime()
	for i = table.getn(sentpetspell),1,-1 do
		if time >= sentpetspell[i].timestart + sentpetspell[i].casttime then
			--DoTimer_CreateSpellTimer(sentspell[i])
			DoTimer_Debug("passing "..sentpetspell[i].spell.." to finalpetspell")
			local finalpetspellentry = {}
			for index,value in sentpetspell[i] do finalpetspellentry[index] = value end
			finalpetspellentry.timestart = GetTime()
			table.insert(finalpetspell,finalpetspellentry)
			if table.getn(finalpetspell) == 1 then 
				DoTimerPreTimerFrame:SetScript("OnUpdate",function() DoTimer_CheckPreTimers() end)
				DoTimerPetIconFrame:SetScript("OnUpdate",function() DoTimer_AwaitPetIcon() end) 
			end
			table.remove(sentpetspell,i)
			if table.getn(sentpetspell) == 0 then DoTimerPetDelayFrame:SetScript("OnUpdate",nil) end
		end
	end
end

function DoTimer_AwaitPetIcon() --waiting for the icon to appear onits target before creating the timer
	local units = {"pettarget","target"}
	for index,value in units do
		local debuffs = DoTimer_ListDebuffs(value)
		for i = table.getn(finalpetspell),1,-1 do
			if finalpetspell[i].unit == value  then
				local found
				if not (finalpetspell[i].target == UnitName("target") and finalpetspell[i].targetsex == UnitSex("target") and finalpetspell[i].targetlevel == UnitLevel("target")) then 
					found = 1
				else
					for index,value in debuffs do
						if finalpetspell[i].spell == value then
							found = 1
							break
						end
					end
				end
				if found then
					DoTimer_Debug("creating a timer for "..finalpetspell[i].spell)
					DoTimer_CreateSpellTimer(finalpetspell[i])
					table.remove(finalpetspell,i)
				end
			end
		end
		if table.getn(finalpetspell) == 0 then DoTimerPetIconFrame:SetScript("OnUpdate",nil) end
	end
end

function DoTimer_ReturnPetInfo(spell) ----used to be longer; i used to save the data in tables, but due to the fact that this data sometimes changes and not b/c of talents, im gonna parse it every time
	return DoTimer_ReturnTexture(spell),DoTimer_ReturnDuration(spell),DoTimer_ReturnCastTime(spell)
end

------------------------------------------------------------------------------------------------------------
-- ############### MACRO FUNCTIONS ################# --
------------------------------------------------------------------------------------------------------------

function DoT_IsPSpell(spellname) --the function for macros to test for own debuffs on target
	DoTimer_Debug("DoT_IsPSpell")
	if not UnitName("target") then return true end -- sigh
	if DoTimer_ReturnEnglish(spellname) == "Immolate" and (DoTimer_Settings.preventimmol[UnitName("target")] or preventingimmol) then  --prevents immolate on certain mobs
		DoTimer_Debug("immolate prevented")
		return true 
	end 
	if not DoT_OwnSpellOnTarget(spellname) then 
		CastSpellByName(spellname.."()") 
		return false
	end
	return true
end

function DoT_OwnSpellOnTarget(spellname,unit) --do you have that spell on your target?	
	DoTimer_Debug("DoT_OwnSpellOnTarget")
	if not unit then unit = "target" end
	if DoT_SpellInAir(spellname,unit) or (DoT_TimerOnTarget(spellname,unit) and DoT_SpellIconOnTarget(spellname,unit)) then return true end
	return false
end

function DoT_SpellInAir(spellname,unit) --if the spell is in any of the holding tables (cast, but not applied as a timer yet)
	DoTimer_Debug("DoT_SpellInAir")
	if not unit then unit = "target" end
	local found
	for i = 1,table.getn(sentspell) do
		if sentspell[i].spell == spellname and sentspell[i].target == UnitName(unit) and sentspell[i].targetlevel == UnitLevel(unit) and sentspell[i].targetsex == UnitSex(unit) then 
			DoTimer_Debug(spellname.." was in sentspell")
			return true 
		end
	end
	for i = table.getn(incomingspell),1,-1 do
		if incomingspell[i].spell == spellname and incomingspell[i].target == UnitName(unit) and incomingspell[i].targetlevel == UnitLevel(unit) and incomingspell[i].targetsex == UnitSex(unit) then 
			DoTimer_Debug(spellname.." was in incomingspell")
			return true 
		end
	end
	for i = table.getn(finalspell),1,-1 do
		if finalspell[i].spell == spellname and finalspell[i].target == UnitName(unit) and finalspell[i].targetlevel == UnitLevel(unit) and finalspell[i].targetsex == UnitSex(unit) then 
			DoTimer_Debug(spellname.." was in finalspell")
			return true
		end
	end
	for i = table.getn(castpetspell),1,-1 do
		if castpetspell[i].spell == spellname and castpetspell[i].target == UnitName(unit) and castpetspell[i].targetlevel == UnitLevel(unit) and castpetspell[i].targetsex == UnitSex(unit) then 
			DoTimer_Debug(spellname.." was in castpetspell")
			return true 
		end
	end
	for i = table.getn(casthealspell),1,-1 do
		if casthealspell[i].spell == spellname and casthealspell[i].target == UnitName(unit) and casthealspell[i].targetlevel == UnitLevel(unit) and casthealspell[i].targetsex == UnitSex(unit) then 
			DoTimer_Debug(spellname.." was in casthealspell")
			return true 
		end
	end
	for i = table.getn(sentpetspell),1,-1 do
		if sentpetspell[i].spell == spellname and sentpetspell[i].target == UnitName(unit) and sentpetspell[i].targetlevel == UnitLevel(unit) and sentpetspell[i].targetsex == UnitSex(unit) then 
			DoTimer_Debug(spellname.." was in sentpetspell")
			return true 
		end
	end
	for i = table.getn(finalpetspell),1,-1 do
		if finalpetspell[i].spell == spellname and finalpetspell[i].target == UnitName(unit) and finalpetspell[i].targetlevel == UnitLevel(unit) and finalpetspell[i].targetsex == UnitSex(unit) then 
			DoTimer_Debug(spellname.." was in finalpetspell")
			return true 
		end
	end
	DoTimer_Debug(spellname.." not in any pre-timer tables")
	return false
end

function DoT_SpellIconOnTarget(spellname,unit) --if that spell is actually on the target
	DoTimer_Debug("DoT_SpellIconOnTarget")
	if not unit then unit = "target" end
	local i = 1
	while UnitDebuff(unit,i) do --scanning each debuff of our target
		DoTimerScanningFrame:ClearLines()
		DoTimerScanningFrame:SetUnitDebuff(unit,i)
		if DoTimerScanningFrameTextLeft1:GetText() == spellname then --it matches the debuff queried
			DoTimer_Debug(spellname.." was a debuff on the target")
			return true
		end
		i = i + 1
	end
	i = 1
	while UnitBuff(unit,i) do --scanning each debuff of our target
		DoTimerScanningFrame:ClearLines()
		DoTimerScanningFrame:SetUnitBuff(unit,i)
		if DoTimerScanningFrameTextLeft1:GetText() == spellname then --it matches the buff queried
			DoTimer_Debug(spellname.. "was a buff on the target")
			return true
		end
		i = i + 1
	end
	DoTimer_Debug(spellname.." not found on target")
	return false
end

function DoT_TimerOnTarget(spellname,unit) --if we currently have a timer for that spell on that unit
	DoTimer_Debug("DoT_TimerOnTarget")
	if not unit then unit = "target" end
	local found = DoTimer_ReturnTable(UnitName(unit),UnitSex(unit),UnitLevel(unit))
	if not found then --there wasn't one
		--DEFAULT_CHAT_FRAME:AddMessage("No debuffs on "..UnitName("target"))
		DoTimer_Debug(spellname.." had no timer table")
		return false
	end
	for i = 1,table.getn(casted[found]) do --oh there was one! is that debuff in the debuff table for that target?
		if casted[found][i].spell == spellname and (DoTimer_TimerIsReal(found,i) or (DoTimer_Settings.probable and casted[found][i].dep)) then --only want real debuffs or heal timers (not ghost or depreciated or fake), but includes dep. if probable setting is on
			--DEFAULT_CHAT_FRAME:AddMessage(spellname.." found on "..UnitName("target"))
			DoTimer_Debug(spellname.." had an associated timer in target's table")
			return found,i  --seems as though it was
		end
	end
	--DEFAULT_CHAT_FRAME:AddMessage("There were debuffs on "..UnitName("target")..", but not "..spellname)
	DoTimer_Debug(spellname.." was not one of the timers on the target")
	return false
end

function DoT_ReturnElapsed(spellname,unit) --returns how long ago spell was cast on unit
	DoTimer_Debug("DoT_ReturnElapsed")
	if not unit then unit = "target" end
	local found,i = DoT_TimerOnTarget(spellname,unit)
	if found and i then return GetTime() - casted[found][i].time end --seems as though it was, return how many seconds ago it was cast 
	return 0 --there were debuffs, but not that spell
end

function DoT_ReturnRemaining(spellname,unit) --returns how much time a spell has left on unit
	DoTimer_Debug("DoT_ReturnRemaining")
	if not unit then unit = "target" end
	local found,i = DoT_TimerOnTarget(spellname,unit)
	if found and i then return casted[found][i].duration - GetTime() + casted[found][i].time end --seems as though it was, return how many seconds it has left 
	return DoTimer_ReturnDuration(spellname,DoTimer_ReturnRank(spellname))  --there were debuffs, but not that spell
end

function DoT_IsSpell(spellname) --the function for macros to test for any occurences of debuffs on target
	DoTimer_Debug("DoT_IsSpell")
	if not UnitName("target") then return true end -- sigh
	if DoTimer_ReturnEnglish(spellname) == "Immolate" and (DoTimer_Settings.preventimmol[UnitName("target")] or preventingimmol) then  --prevents immolate on certain mobs
		DoTimer_Debug("immolate prevented")
		return true 
	end 
	if not DoT_SpellOnTarget(spellname) then 
		CastSpellByName(spellname.."()")
		return false
	end
	return true
end 

function DoT_SpellOnTarget(spellname,unit) --is the spell on your target?
	DoTimer_Debug("DoT_SpellOnTarget")
	if not unit then unit = "target" end
	if DoT_SpellInAir(spellname,unit) or DoT_SpellIconOnTarget(spellname,unit) then return true end
	return false
end

function DoT_DetermineSpell(spell1,spell2) --another macro function with some more complicated logic
	DoTimer_Debug("DoT_DetermineSpell")
	if not UnitName("target") then return true end -- sigh
	if not DoT_SpellOnTarget(spell1) then CastSpellByName(spell1) return false end
	if (not DoT_OwnSpellOnTarget(spell1)) and (not DoT_OwnSpellOnTarget(spell2)) then CastSpellByName(spell2) return false end
	return true
end

------------------------------------------------------------------------------------------------------------
-- ############## INTERFACE FUNCTIONS ################ --
------------------------------------------------------------------------------------------------------------

function DoTimer_CreateInterface() --defines the major portion of writing to the screen; it is called when something drastic has to happen to the interface (i.e., not just updating a timer)
	if DoTimer_Settings.visible then
		DoTimer_SortTimers()
		local time = GetTime()
		if table.getn(casted) == 0 then DoTimerFrame:SetScript("OnUpdate",nil) end --to save memory, the OnUpdate function won't be called at all if there are no timers
		if table.getn(casted) == 1 then DoTimerFrame:SetScript("OnUpdate",function() DoTimer_OnUpdate() end) end --restoring that OnUpdate
		for i = 1,table.getn(casted) do --displaying the information onscreen for each target
			getglobal("DoTimerTarget"..i):Show()
			for id = 1,table.getn(casted[i]) do --for each debuff on the target
				getglobal("DoTimerTarget"..i.."Debuff"..id):Show()
				getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTextureIcon"):SetTexture(casted[i][id].texture) --setting the icon
				local remaining = casted[i][id].duration - time + casted[i][id].time
				getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTime"):SetText(DoTimer_ReturnNewDuration(remaining)) --setting the time remaining
				local r,g,b
				if casted[i][id].type == "ghost" then r,g,b = 1,0,1
				elseif remaining <= 5 and DoTimer_Settings.redtext then r,g,b = 1,.2,.2
				else r,g,b = 1,.82,0	
				end
				getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTime"):SetTextColor(r,g,b) --setting the color of the time remaining
				local alpha
				if casted[i][id].dep then alpha = .5 else alpha = 1 end
				getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTextureIcon"):SetAlpha(alpha) --setting the alpha of the icon
			end
		end
		for i = 1,10 do
			if (not casted[i]) then 
				getglobal("DoTimerTarget"..i):Hide() --hiding unused targets
			else
				if DoTimer_Settings.names then --set the target name if you have them on, else hide it
					getglobal("DoTimerTarget"..i.."Name"):Show()
					getglobal("DoTimerTarget"..i.."Name"):SetText(string.gsub(casted[i].target," ","\n"))
				else
					getglobal("DoTimerTarget"..i.."Name"):Hide()
				end
				for id = 1,20 do
					if (not casted[i][id]) then getglobal("DoTimerTarget"..i.."Debuff"..id):Hide() end --hiding unused debuffs in used targets
				end
			end
		end
		DoTimer_ResizeInterface()
	end
end

function DoTimer_SortTimers() --separated the timers by their type then arranges by time added or time remaining
	for i = table.getn(casted),1,-1 do
		local regtimers = {} --the 5 different types that timers can be
		local deptimers = {}
		local ghosttimers = {}
		local faketimers = {}
		local healtimers = {}
		for id = table.getn(casted[i]),1,-1 do --sorting into correct table
			local intable, type
			type = casted[i][id].type
			if casted[i][id].dep then intable = deptimers
			elseif type == "ghost" then intable = ghosttimers
			elseif type == "fake" then intable = faketimers
			elseif type == "heal" then intable = healtimers
			else intable = regtimers
			end
			table.insert(intable,casted[i][id])
			table.remove(casted[i],id)
		end
		local time = GetTime()
		local tables = {regtimers,deptimers,ghosttimers,faketimers}
		if DoTimer_Settings.sortbyadded == false then --sorting the temp tables by time added or time remaining
			for index,value in tables do
				table.sort(value,function(a,b) return (a.duration - time + a.time) < (b.duration - time + b.time) end)
			end
		else
			for index,value in tables do
				table.sort(value,function(a,b) return (a.time) < (b.time) end)
			end		
		end
		for id = 1,table.getn(regtimers) do table.insert(casted[i],regtimers[id]) end --inserting them back into the main table in the order i want them displayed onscreen
		for id = 1,table.getn(healtimers) do table.insert(casted[i],healtimers[id]) end
		for id = 1,table.getn(ghosttimers) do table.insert(casted[i],ghosttimers[id]) end
		for id = 1,table.getn(deptimers) do table.insert(casted[i],deptimers[id]) end
		for id = 1,table.getn(faketimers) do table.insert(casted[i],faketimers[id]) end
	end
end

function DoTimer_ButtonClicked(index,indexid) --the script for when an icon is clicked
	if IsShiftKeyDown() then --delete it
		table.remove(casted[index],indexid)
		if table.getn(casted[index]) == 0 then 
			table.remove(casted,index)
		end
		DoTimer_CreateInterface()
	elseif IsControlKeyDown() then --make it a ghost timer
		if DoTimer_TimerIsReal(index,indexid) then DoTimer_CreateGhostTimer(index,indexid) end
	else --target the mob, or, if ghost, target or cast spell
		if casted[index][indexid].type == "ghost" then
			if casted[index].target == UnitName("target") and casted[index].level == UnitLevel("target") and casted[index].sex == UnitSex("target") then 
				CastSpellByName(casted[index][indexid].spell.."("..casted[index][indexid].rank..")") 
			else 
				TargetByName(casted[index].target) 
			end
		else
			if not (casted[index].target == UnitName("target") and casted[index].level == UnitLevel("target") and casted[index].sex == UnitSex("target")) then TargetByName(casted[index].target) end
		end
	end
end

function DoTimer_AddTimers(numtargets,numdebuffs) --used to view different interface layouts
	DoTimer_DelTimers()
	for i = 1,(numtargets or DoTimer_Settings.maxtargets) do
		getglobal("DoTimerTarget"..i):Show()
		if DoTimer_Settings.names then 
			getglobal("DoTimerTarget"..i.."Name"):Show()
			getglobal("DoTimerTarget"..i.."Name"):SetText("Target\nName\nNumber "..i)
		end
		for id = 1,(numdebuffs or DoTimer_Settings.maxdebuffs) do
			getglobal("DoTimerTarget"..i.."Debuff"..id):Show()
			getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTextureIcon"):SetTexture(GetSpellTexture(id,BOOKTYPE_SPELL))
			getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTime"):SetText("0:00")
		end
	end
	DoTimer_ResizeInterface()
end

function DoTimer_DelTimers() --used to hide the "fake" timers created by the above function
	for i = 1,10 do
		getglobal("DoTimerTarget"..i):Hide()
		getglobal("DoTimerTarget"..i.."Name"):Hide()
		for id = 1,20 do
			getglobal("DoTimerTarget"..i.."Debuff"..id):Hide()
		end
	end
end

function DoTimer_DefineInterface(targetsetup,debuffsetup,startup) --the controller behind the 12 different interface layouts
	local oldtargetsetup = DoTimer_Settings.targetlayout
	local olddebuffsetup = DoTimer_Settings.debufflayout
	DoTimer_Settings.targetlayout = targetsetup
	DoTimer_Settings.debufflayout = debuffsetup
	local ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10
	local num1,num2,num3,num4,num5,num6,num7,num8
	--ref1/2: name string to target frame: the name is anchored by (1) to the target's (2)
	--ref3/4: time string to debuff texture: the timer is anchored by (3) to the texture's (4)
	--ref5/6 the anchor corner/its opposite: the 1st target is anchored by (5) to the drag icon's (6)
	--ref7: corner for the other targets: the next target is anchored by (5) to the current's (7)
	--ref8/9: anchors for the debuffs: the next debuff is anchored by its (9) to the previous's (8) (reversed order than usual)
	--ref10: anchor for the 1st debuff; it is connected by its (10) to the target frame's (10)
	--num1/2: dist. between name string and target: you go left (1) and up (2) to go from target to name
	--num3/4: dist. between time string and texture: you go left (3) and up (4) to go from texture to timer
	--num5/6: dist. between debuffs: you go left (5) and up (6) to go from one debuff to the next
	--num7/8: dist. between targets: you go left (7) and up (8) to go from one target to the next
	if targetsetup == "up" and debuffsetup == "left" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "LEFT","RIGHT","TOP","BOTTOM","BOTTOMRIGHT","TOPLEFT","TOPRIGHT","LEFT","RIGHT","BOTTOMRIGHT"
		num1,num2,num3,num4,num5,num6,num7,num8 = 5,0,0,-5,-5,0,0,5
	elseif targetsetup == "down" and debuffsetup == "left" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "LEFT","RIGHT","TOP","BOTTOM","TOPRIGHT","BOTTOMLEFT","BOTTOMRIGHT","LEFT","RIGHT","TOPRIGHT"
		num1,num2,num3,num4,num5,num6,num7,num8 = 5,0,0,-5,-5,0,0,-5
	elseif targetsetup == "left" and debuffsetup == "up" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "TOP","BOTTOM","LEFT","RIGHT","BOTTOMRIGHT","TOPLEFT","BOTTOMLEFT","TOP","BOTTOM","BOTTOMRIGHT"
		num1,num2,num3,num4,num5,num6,num7,num8 = 0,-5,5,0,0,5,-5,0
	elseif targetsetup == "right" and debuffsetup == "up" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "TOP","BOTTOM","LEFT","RIGHT","BOTTOMLEFT","TOPRIGHT","BOTTOMRIGHT","TOP","BOTTOM","BOTTOMLEFT"
		num1,num2,num3,num4,num5,num6,num7,num8 = 0,-5,5,0,0,5,5,0
	elseif targetsetup == "up" and debuffsetup == "right" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "RIGHT","LEFT","TOP","BOTTOM","BOTTOMLEFT","TOPRIGHT","TOPLEFT","RIGHT","LEFT","BOTTOMLEFT"
		num1,num2,num3,num4,num5,num6,num7,num8 = -5,0,0,-5,5,0,0,5
	elseif targetsetup == "down" and debuffsetup == "right" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "RIGHT","LEFT","TOP","BOTTOM","TOPLEFT","BOTTOMRIGHT","BOTTOMLEFT","RIGHT","LEFT","TOPLEFT"
		num1,num2,num3,num4,num5,num6,num7,num8 = -5,0,0,-5,5,0,0,-5
	elseif targetsetup == "left" and debuffsetup == "down" then --default!
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "BOTTOM","TOP","LEFT","RIGHT","TOPRIGHT","BOTTOMLEFT","TOPLEFT","BOTTOM","TOP","TOPRIGHT"
		num1,num2,num3,num4,num5,num6,num7,num8 = 0,5,5,0,0,-5,-5,0
	elseif targetsetup == "right" and debuffsetup == "down" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "BOTTOM","TOP","LEFT","RIGHT","TOPLEFT","BOTTOMRIGHT","TOPRIGHT","BOTTOM","TOP","TOPLEFT"
		num1,num2,num3,num4,num5,num6,num7,num8 = 0,5,5,0,0,-5,5,0
	elseif targetsetup == "right" and debuffsetup == "right" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "BOTTOMLEFT","TOPLEFT","TOP","BOTTOM","TOPLEFT","BOTTOMRIGHT","TOPRIGHT","RIGHT","LEFT","TOPLEFT"
		num1,num2,num3,num4,num5,num6,num7,num8 = 0,5,0,-5,5,0,5,0
	elseif targetsetup == "down" and debuffsetup == "down" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "TOPRIGHT","TOPLEFT","LEFT","RIGHT","TOPLEFT","BOTTOMRIGHT","BOTTOMLEFT","BOTTOM","TOP","TOPLEFT"
		num1,num2,num3,num4,num5,num6,num7,num8 = -5,0,5,0,0,-5,0,-5
	elseif targetsetup == "left" and debuffsetup == "left" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "BOTTOMRIGHT","TOPRIGHT","TOP","BOTTOM","TOPRIGHT","BOTTOMLEFT","TOPLEFT","LEFT","RIGHT","TOPRIGHT"
		num1,num2,num3,num4,num5,num6,num7,num8 = 0,5,0,-5,-5,0,-5,0
	elseif targetsetup == "up" and debuffsetup == "up" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "BOTTOMRIGHT","BOTTOMLEFT","LEFT","RIGHT","BOTTOMLEFT","TOPRIGHT","TOPLEFT","TOP","BOTTOM","BOTTOMLEFT"
		num1,num2,num3,num4,num5,num6,num7,num8 = -5,0,5,0,0,5,0,5
	elseif targetsetup == "up" and debuffsetup == "down" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "TOPRIGHT","TOPLEFT","LEFT","RIGHT","BOTTOMLEFT","TOPRIGHT","TOPLEFT","BOTTOM","TOP","TOPLEFT"
		num1,num2,num3,num4,num5,num6,num7,num8 = -5,0,5,0,0,-5,0,5
	elseif targetsetup == "down" and debuffsetup == "up" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "BOTTOMRIGHT","BOTTOMLEFT","LEFT","RIGHT","TOPLEFT","BOTTOMRIGHT","BOTTOMLEFT","TOP","BOTTOM","BOTTOMLEFT"
		num1,num2,num3,num4,num5,num6,num7,num8 = -5,0,5,0,0,5,0,-5
	elseif targetsetup == "left" and debuffsetup == "right" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "BOTTOMLEFT","TOPLEFT","TOP","BOTTOM","TOPRIGHT","BOTTOMLEFT","TOPLEFT","RIGHT","LEFT","TOPLEFT"
		num1,num2,num3,num4,num5,num6,num7,num8 = 0,5,0,-5,5,0,-5,0
	elseif targetsetup == "right" and debuffsetup == "left" then
		ref1,ref2,ref3,ref4,ref5,ref6,ref7,ref8,ref9,ref10 = "BOTTOMRIGHT","TOPRIGHT","TOP","BOTTOM","TOPLEFT","BOTTOMRIGHT","TOPRIGHT","LEFT","RIGHT","TOPRIGHT"
		num1,num2,num3,num4,num5,num6,num7,num8 = 0,5,0,-5,-5,0,5,0
	else
		DoTimer_AddText("Failure to change interface design! No changes made.")
		DoTimer_Settings.targetlayout = oldtargetsetup
		DoTimer_Settings.debufflayout = olddebuffsetup
	end
	if (not (DoTimer_Settings.targetlayout == oldtargetsetup)) or (not (DoTimer_Settings.debufflayout == olddebuffsetup)) or (startup) then 
		for i = 1,10 do
			getglobal("DoTimerTarget"..i):ClearAllPoints()
			getglobal("DoTimerTarget"..i.."Name"):ClearAllPoints()
			getglobal("DoTimerTarget"..i.."Name"):SetPoint(ref1,"DoTimerTarget"..i,ref2,num1,num2)
			for id = 1,20 do
				getglobal("DoTimerTarget"..i.."Debuff"..id):ClearAllPoints()
				getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTime"):ClearAllPoints()
				getglobal("DoTimerTarget"..i.."Debuff"..id.."DisplayedTime"):SetPoint(ref3,"DoTimerTarget"..i.."Debuff"..id.."DisplayedTexture",ref4,num3,num4)
			end
		end
		for i = 1,10 do
			getglobal("DoTimerTarget"..i.."Debuff1"):SetPoint(ref10,"DoTimerTarget"..i,ref10)
			for id = 2,20 do
				getglobal("DoTimerTarget"..i.."Debuff"..id):SetPoint(ref9,"DoTimerTarget"..i.."Debuff"..(id-1),ref8,num5,num6)
			end
		end
		getglobal("DoTimerTarget1"):SetPoint(ref5,"DoTimerMainFrame",ref6)
		for i = 2,10 do
			getglobal("DoTimerTarget"..i):SetPoint(ref5,"DoTimerTarget"..(i-1),ref7,num7,num8)
		end
		DoTimer_ResizeInterface() 
	end
end

function DoTimer_ResizeInterface() --resizes the frames that hold the debuffs so that they are more tightly compacted on the screen
	local maxwidth,maxheight,otherwidth,otherheight,nameheight,namewidth,targetwidth,targetheight
	DoTimerFontTestText:SetText("Vaelastrasz\nthe\nCorrupt") --the target names will be normalized to this name; as it is exceedingly long
	if DoTimer_Settings.names then nameheight,namewidth = DoTimerFontTestText:GetHeight(),DoTimerFontTestText:GetWidth() else nameheight,namewidth = 0,0 end
	local debuffheight = DoTimerTarget1Debuff1DisplayedTexture:GetHeight() * DoTimerTarget1Debuff1DisplayedTexture:GetScale()
	local debuffwidth = DoTimerTarget1Debuff1DisplayedTexture:GetWidth() * DoTimerTarget1Debuff1DisplayedTexture:GetScale()
	local timerheight = DoTimerTarget1Debuff1DisplayedTime:GetHeight()
	local timerwidth = DoTimerTarget1Debuff1DisplayedTime:GetWidth()
	local d = DoTimer_Settings.debufflayout
	if d == "up" or d == "down" then -- wider than they are tall
		maxwidth = math.max(namewidth,debuffwidth + timerwidth + 5)
		maxheight = math.max(debuffheight,timerheight)
		otherwidth = debuffwidth + timerwidth + 5
		otherheight = debuffheight
		targetwidth = maxwidth
		targetheight = math.max(nameheight,maxheight)
	else --taller than they are wide
		maxwidth = math.max(debuffwidth,timerwidth)
		maxheight = math.max(nameheight,debuffheight + timerheight + 5)
		otherwidth = debuffwidth
		otherheight = debuffheight + timerheight + 5
		targetwidth = math.max(namewidth,maxwidth)
		targetheight = maxheight
	end
	for i = 1,10 do
		local num = DoTimer_GetNumDebuffs(i)
		if d == "up" or d == "down" then
			getglobal("DoTimerTarget"..i):SetWidth(targetwidth)
			getglobal("DoTimerTarget"..i):SetHeight(math.max(targetheight,(num * (maxheight + 5)) - 5))
		else
			getglobal("DoTimerTarget"..i):SetWidth(math.max(targetwidth,(num * (maxwidth + 5)) - 5))
			getglobal("DoTimerTarget"..i):SetHeight(targetheight)		
		end
		for id = 1,20 do
			getglobal("DoTimerTarget"..i.."Debuff"..id):SetWidth(maxwidth)
			getglobal("DoTimerTarget"..i.."Debuff"..id):SetHeight(maxheight)
			getglobal("DoTimerTarget"..i.."Debuff"..id.."Displayed"):SetWidth(otherwidth)
			getglobal("DoTimerTarget"..i.."Debuff"..id.."Displayed"):SetHeight(otherheight)
		end
	end
end 

function DoTimer_GetNumDebuffs(i) --returns how many debuff icons for that target are currently being shown
	for id = 20,1,-1 do
		if getglobal("DoTimerTarget"..i.."Debuff"..id):IsVisible() then return id end
	end
	return 0
end

function DoTimer_SimulateTimer(spell,target) --used to make a fake timer, no real reason for it
	local rank = DoTimer_ReturnRank(spell)
	local sex,level,type
	if UnitName("target") == target then
		sex = UnitSex("target")
		level = UnitLevel("target")
		type = DoTimer_ReturnTargetType("target")
	end
	if not sex then sex = 0 end
	if not level then level = 60 end
	if not type then type = "player" end
	local texture,duration = DoTimer_ReturnInfo(spell,rank)
	local spelltable = {spell = spell, rank = rank, texture = texture, duration = duration, target = target, targetsex = sex, targetlevel = level, targettype = type, timertype = "fake"}
	DoTimer_CreateSpellTimer(spelltable)
end

function DoTimer_CreateGhostTimer(found,i) --makes the ghost timer once a spell is control+clicked
	local basedspell = casted[found][i]
	local basedtarget = casted[found]
	local spelltable = {spell = basedspell.spell, rank = basedspell.rank, texture = basedspell.texture, duration = 300, target = basedtarget.target, targetsex = basedtarget.sex, targetlevel = basedtarget.level, targettype = basedtarget.type, timertype = "ghost"}
	DoTimer_CreateSpellTimer(spelltable)
end

function DoTimer_RemoveAllTimers() --deletes all the timers on the screen
	for i = table.getn(casted),1,-1 do
		for id = table.getn(casted[i]),1,-1 do
			DoTimer_RemoveTimer(i,id)
		end
	end
end

function DoTimer_CreateSimulatedDisplay() --creates a display of fake timers (used by me to take screenshots)
	local curses = {
		"Curse of Weakness",
		"Curse of Agony",
		"Curse of Shadow",
		"Curse of Doom",
	}
	local debuffs = {
		"Immolate",
		"Corruption",
		"Banish",
		"Fear",
	}
	local targets = {
		"Target Three Words",
		"Target Two",
		"PlayerX"
	}
	for index,value in targets do
		DoTimer_SimulateTimer(curses[math.random(4)],value)
		for i = 1,2 do
			DoTimer_SimulateTimer(debuffs[math.random(4)],value)
		end
	end
	for i = table.getn(casted) - 1,1,-1 do
		casted[i][1].dep = 1
		casted[i][1].type = "debuff"
		casted[i][1].depstart = GetTime()
		DoTimer_CreateInterface()
	end
	casted[1][1].type = "debuff"
	DoTimer_CreateGhostTimer(1,1)
end

function DoTimer_CycleViews(num,targets,debuffs) --cycles through all 16 interfaces, relies on another addon i wrote to function
	if not num then num = 3 end
	if not targets then targets = 3 end
	if not debuffs then debuffs = 5 end
	DoTimer_Commands("reset position")
	DoTimer_Commands(string.format("show %d %d",targets,debuffs))
	DoTimer_Commands("set layout left left")
	SlashCmdList["NTIMER"]((1 * num).." /script DoTimer_Commands(\"set layout left right\")")
	SlashCmdList["NTIMER"]((2 * num).." /script DoTimer_Commands(\"set layout left up\")")
	SlashCmdList["NTIMER"]((3 * num).." /script DoTimer_Commands(\"set layout left down\")")
	SlashCmdList["NTIMER"]((4 * num).." /script DoTimer_Commands(\"set layout right left\")")
	SlashCmdList["NTIMER"]((5 * num).." /script DoTimer_Commands(\"set layout right right\")")
	SlashCmdList["NTIMER"]((6 * num).." /script DoTimer_Commands(\"set layout right up\")")
	SlashCmdList["NTIMER"]((7 * num).." /script DoTimer_Commands(\"set layout right down\")")
	SlashCmdList["NTIMER"]((8 * num).." /script DoTimer_Commands(\"set layout up left\")")
	SlashCmdList["NTIMER"]((9 * num).." /script DoTimer_Commands(\"set layout up right\")")
	SlashCmdList["NTIMER"]((10 * num).." /script DoTimer_Commands(\"set layout up up\")")
	SlashCmdList["NTIMER"]((11 * num).." /script DoTimer_Commands(\"set layout up down\")")
	SlashCmdList["NTIMER"]((12 * num).." /script DoTimer_Commands(\"set layout down left\")")
	SlashCmdList["NTIMER"]((13 * num).." /script DoTimer_Commands(\"set layout down right\")")
	SlashCmdList["NTIMER"]((14 * num).." /script DoTimer_Commands(\"set layout down up\")")
	SlashCmdList["NTIMER"]((15 * num).." /script DoTimer_Commands(\"set layout down down\")")
end
	