--The master behind all spells.  To add a custom spell:
--first you need to discover its texture, and add it in the format below.  if it is for another class, you may need to make a table for that class.
--the "name" entry is the english name
-- the "duration" entry is the duration, in either seconds or minutes, whichever applicable.  note that the way that the addon parses duration is it chooses the number closest to this one.  choose it wisely
-- the "multiplier" entry is 1 for seconds, or 60 for minutes
-- then you have to add it to a table in the DefineSpells function, so the addon knows how to track it.  debuff/pet/heal/enslave
-- right now the abbreviations mean nothing; they might in a future patch

DoTimer_SpellData = { --a list of textures (same in all locales!) and the english name equivilents.  used to free the chore of localizing the spell names.  also provides the average duration and the second/minute multiplier
	["WARLOCK"] = {
		["Interface\\Icons\\Spell_Shadow_CurseOfTounges"] = {
			["name"] = "Curse of Tongues",
			["duration"] = 30,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_AbominationExplosion"] = {
			["name"] = "Corruption",
			["duration"] = 12,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Fire_Immolation"] = {
			["name"] = "Immolate",
			["duration"] = 15,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_SummonInfernal"] = {
			["name"] = "Inferno",
			["duration"] = 5,
			["multiplier"] = 60,
		},
		["Interface\\Icons\\Spell_Shadow_DeathCoil"] = {
			["name"] = "Death Coil",
			["duration"] = 3,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_AuraOfDarkness"] = {
			["name"] = "Curse of Doom",
			["duration"] = 1,
			["multiplier"] = 60,
		},
		["Interface\\Icons\\Spell_Shadow_EnslaveDemon"] = {
			["name"] = "Enslave Demon",
			["duration"] = 5,
			["multiplier"] = 60,
		},
		["Interface\\Icons\\Spell_Shadow_MindSteal"] = {
			["name"] = "Seduction",
			["duration"] = 15,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_CurseOfSargeras"] = {
			["name"] = "Curse of Agony",
			["duration"] = 24,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_CurseOfMannoroth"] = {
			["name"] = "Curse of Weakness",
			["duration"] = 2,
			["multiplier"] = 60,
		},
		["Interface\\Icons\\Spell_Shadow_UnholyStrength"] = {
			["name"] = "Curse of Recklessness",
			["duration"] = 2,
			["multiplier"] = 60,
		},
		["Interface\\Icons\\Spell_Shadow_CurseOfAchimonde"] = {
			["name"] = "Curse of Shadow",
			["duration"] = 5,
			["multiplier"] = 60,
		},
		["Interface\\Icons\\Spell_Shadow_Cripple"] = {
			["name"] = "Banish",
			["duration"] = 20,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_ChillTouch"] = {
			["name"] = "Curse of the Elements",
			["duration"] = 5,
			["multiplier"] = 60,
		},
		["Interface\\Icons\\Spell_Shadow_MindRot"] = {
			["name"] = "Spell Lock",
			["duration"] = 8,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_Possession"] = {
			["name"] = "Fear",
			["duration"] = 15,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_DeathScream"] = {
			["name"] = "Howl of Terror",
			["duration"] = 16,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Fire_Fireball"] = {
			["name"] = "Conflagrate", 
		},
		["Interface\\Icons\\Spell_Shadow_Requiem"] = {
			["name"] = "Siphon Life",
			["duration"] = 30,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_BurningSpirit"] = {
			["name"] = "Life Tap",
		},
	},
	["PRIEST"] = {
		["Interface\\Icons\\Spell_Nature_Slow"] = {
			["name"] = "Shackle Undead", 
			["duration"] = 30,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Holy_MindSooth"] = {
			["name"] = "Mind Soothe",  
			["duration"] = 15,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Nature_NullifyDisease"] = {
			["name"] = "Abolish Disease",  
			["duration"] = 20,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_ShadowWordPain"] = {
			["name"] = "Shadow Word: Pain",  
			["duration"] = 18,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_PsychicScream"] = {
			["name"] = "Psychic Scream",  
			["duration"] = 8,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_BlackPlague"] = {
			["name"] = "Devouring Plague",  
			["duration"] = 24,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Holy_Renew"] = {
			["name"] = "Renew", 	 
			["duration"] = 15,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Holy_PowerWordShield"] = {
			["name"] = "Power Word: Shield",  
			["duration"] = 15,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Shadow_FingerOfDeath"] = {
			["name"] = "Hex of Weakness", 
			["duration"] = 2,
			["multiplier"] = 60,
		},
		["Interface\\Icons\\Spell_Shadow_UnsummonBuilding"] = {
			["name"] = "Vampiric Embrace", 
			["duration"] = 1,
			["multiplier"] = 60,
		},
	},
	["DRUID"] = {
		["Interface\\Icons\\Ability_GhoulFrenzy"] = {
			["name"] = "Rip",  
			["duration"] = 12,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Nature_FaerieFire"] = {
			["name"] = "Faerie Fire",  
			["duration"] = 40,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Nature_Rejuvenation"] = {
			["name"] = "Rejuvenation",  
			["duration"] = 12,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Nature_StrangleVines"] = {
			["name"] = "Entangling Roots",  
			["duration"] = 12,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Nature_NullifyPoison_02"] = {
			["name"] = "Abolish Poison",  
			["duration"] = 8,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Ability_Druid_Disembowel"] = {
			["name"] = "Rake",  
			["duration"] = 9,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Nature_Sleep"] = {
			["name"] = "Hibernate",  
			["duration"] = 20,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Nature_ResistNature"] = {
			["name"] = "Regrowth",  
			["duration"] = 21,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Ability_Hunter_BeastSoothe"] = {
			["name"] = "Soothe Animal",  
			["duration"] = 15,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Spell_Nature_InsectSwarm"] = {
			["name"] = "Insect Swarm", 
			["duration"] = 12,
			["multiplier"] = 1,
		},
	},
	["HUNTER"] = {
		["Interface\\Icons\\Ability_Hunter_CriticalShot"] = {
			["name"] = "Scorpid Sting", 
			["duration"] = 20,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Ability_Hunter_Quickshot"] = {
			["name"] = "Serpent Sting", 
			["duration"] = 15,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\INV_Spear_02"] = {
			["name"] = "Wyvern Sting", 
			["duration"] = 12,
			["multiplier"] = 2, --because it is a 12 second sleep and a 12 second DoT
		},
		["Interface\\Icons\\Ability_Rogue_Trip"] = {
			["name"] = "Wing Clip", 
			["duration"] = 10,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Ability_Hunter_AimedShot"] = {
			["name"] = "Viper Sting", 
			["duration"] = 8,
			["multiplier"] = 1,
		},
		["Interface\\Icons\\Ability_Druid_Cower"] = {
			["name"] = "Scare Beast",
			["duration"] = 10,
			["multiplier"] = 1,
		},
	},
}

function DoTimer_DefineSpells(class) --creates the lists of spells to watch for for each class.  also defines their aliases for when i implement them.  DO NOT make the names not english!! i look for english names.  only mess with the abbreviations
	local spells,petspells,healspells,enslavespells = {},{},{},{}
	if class == "WARLOCK" then
		spells = {
			["Curse of Agony"] = "CoA",
			["Curse of Exhaustion"] = "CoEx",
			["Curse of Recklessness"] = "CoR",
			["Curse of the Elements"] = "CoE",
			["Curse of Shadow"] = "CoS",
			["Curse of Weakness"] = "CoW",
			["Curse of Tongues"] = "CoT",
			["Corruption"] = "Corr.",
			["Banish"] = "Bani.",
			["Immolate"] = "Immol.",
			["Siphon Life"] = "Si.L.",
			["Curse of Doom"] = "CoD",
			["Fear"] = "Fear",
			["Howl of Terror"] = "HoT",
			["Death Coil"] = "Dth.Cl.",
		}
		petspells = {
			["Seduction"] = "Sedu.",
			["Spell Lock"] = "Spl.Lck.",
		}
		enslavespells = {
			["Inferno"] = "En.Dem.",
			["Enslave Demon"] = "En.Dem.",
		}
	elseif class == "DRUID" then
		spells = {
			["Entangling Roots"] = "Ent.Rt.",
			["Faerie Fire"] = "FF",
			["Hibernate"] = "Hiber.",
			["Insect Swarm"] = "Ins.Swm.",
			["Rake"] = "Rake",
			["Rip"] = "Rip",
			["Soothe Animal"] = "Sthe.Aml.",
		}
		healspells = {
			["Abolish Poison"] = "Abo.Psn.",
			["Regrowth"] = "Rgth.",
			["Rejuvenation"] = "Rejuv.",
		}
	elseif class == "PRIEST" then
		spells = {
			["Devouring Plague"] = "Dev.Plg.",
			["Hex of Weakness"] = "HoW",
			["Mind Soothe"] = "Mnd.Sthe.",
			["Psychic Scream"] = "Psy.Scrm.",
			["Shackle Undead"] = "Shkl.Und.",
			["Shadow Word: Pain"] = "SW:P",
		}
		healspells = {
			["Abolish Disease"] = "Abo.Dis.",
			["Power Word: Shield"] = "PW:S",
			["Renew"] = "Renew",
		}
	elseif class == "HUNTER" then
		spells = {
			["Scorpid Sting"] = "Sco.Sting",
			["Serpent Sting"] = "Serp.Sting",
			["Viper Sting"] = "Vip.Sting",
			["Wing Clip"] = "Wng.Clp.",
			["Wyvern Sting"] = "Wyv.Sting",
			["Scare Beast"] = "Sc.Bst.",
		}
	end
	return spells,petspells,healspells,enslavespells
end
